#include "rpg.h"

extern SDL_Surface *man[4];

extern SDL_Surface *blank, *screen, *trees, *tree, *tree2, *trees_right_border,
  *trees_side_border, *trees2, *trees_horizontal_border, *house1, *blue_pond,
  *floor1, *table1, *dragon_door, *statue_lake, *trees_top_border_short,
  *merchant1;
extern SDL_Surface *cave_top, *wooden_fence_top, *palace_gate;
extern SDL_Surface *wooden_fence_horizontal, *tree_rectangle, *round_tree,
  *well_of_life, *house2, *house3, *pub, *chapel;
extern SDL_Surface *trees_canvas;
extern SDL_Surface *sign, *sign_shadow, *sign_base;
extern SDL_Surface *magic_sign;
extern SDL_Surface *lamp_base, *lamp_grey;

extern SDL_Surface *magenta_rec; /* rec is used for tree1.bmp */ 
extern SDL_Surface *magenta_rec2; /*rec2 is used for house1 and should be at house1->y+30 and x+18 */
extern SDL_Surface *magenta_rec3; /* rec3 used for shelfs, x+10, y+5 */
extern SDL_Surface *magenta_top; /* a bar that covers the top part of the screen 800x15 */
extern SDL_Surface *spirit[4], *tree3;

extern int ActiveEnemies;
extern struct MonstXY monster[255];
extern struct hero hero;
extern int ManPos;

/* We use this function to detect both our successful attack on an enemy */
/* And an enemies attack on us */
int
HitEnemy (SDL_Surface ** player, int px, int py, SDL_Surface * enemy, int ex,
	  int ey)
{
  if (SDL_CollideBox (player, px, py, enemy, ex, ey, 4, BBOX))
    return 1;

  return 0;
}

int
InBounds (int x, int y, int frame)
{
	
  /* WHEN WE WANT COLLISION DETECTION TO WORK ON COLOR KEYED BITMAPS */
  /* THEN WE USE BOUNDING BOX (BBOX) and NOT PERFECT PIXEL (PIXEL) */
  switch (frame) {
  case MAP_FRAME1:
    if (!SDL_CollideBox (hero.walk[ManPos].image, x, y, magenta_rec, 35, 53, 1, BBOX) &&
	!SDL_CollideBox (hero.walk[ManPos].image, x, y, magenta_rec, T2RO_X(700), T2RO_Y(400), 1, BBOX) &&
	!SDL_CollideBox (hero.walk[ManPos].image, x, y, lamp_base,  L2BO_X(130), L2BO_Y(60), 1, BBOX) &&
	!SDL_CollideBox (hero.walk[ManPos].image, x, y, lamp_base,  L2BO_X(130), L2BO_Y(220), 1, BBOX) &&
	!SDL_CollideBox (hero.walk[ManPos].image, x, y, lamp_base,  L2BO_X(305), L2BO_Y(60), 1, BBOX) &&
	!SDL_CollideBox (hero.walk[ManPos].image, x, y, lamp_base,  L2BO_X(305), L2BO_Y(220), 1, BBOX) &&
	!SDL_CollideBox (hero.walk[ManPos].image, x, y, sign_base,  S2BO_X(700), S2BO_Y(300), 1, BBOX) &&
 	!SDL_CollideBox (hero.walk[ManPos].image, x, y, magic_sign, 400, 50 + HOUSE1_H, 1, BBOX) &&
	!SDL_CollideBox (hero.walk[ManPos].image, x, y, magenta_rec2, 415, 90, 1, BBOX))
	return 1;
    break;
  case MAP_FRAME1_A:
    if (!SDL_CollideBox (hero.walk[ManPos].image, x, y, tree3, 320, 220, 1, BBOX)&&
        !SDL_CollideBox (hero.walk[ManPos].image, x, y, tree3, 0, 0, 1, BBOX))
		 return 1;
    break;
  case MAP_FRAME1_C:
      return 1;
    break;
  case MAP_FRAME1_B:
	
	if (!SDL_CollideBox (hero.walk[ManPos].image, x, y, magenta_rec, T2RO_X(200), T2RO_Y(235), 1, BBOX) &&
	    !SDL_CollideBox (hero.walk[ManPos].image, x, y, magenta_rec, T2RO_X(415), T2RO_Y(40), 1, BBOX) &&
	    !SDL_CollideBox (hero.walk[ManPos].image, x, y, magenta_rec2, 395, 190, 1, BBOX)) 
      		return 1;
	
    break;
  case MAP_FRAME1_D:
      return 1;
    break;
  case MAP_FRAME1_E:
      return 1;
    break;
  case MAP_FRAME1_F:
      return 1;
    break;
  case MAP_FRAME1_G:
    return 1;
  case MAP_FRAME1_H:
    return 1;
  case MAP_FRAME1_I:
    return 1;
  case MAP_FRAME1_J:
    return 1;
  case MAP_FRAME1_K:
    return 1;
  case MAP_FRAME1_L:
      return 1;
    break;
  case MAP_FRAME1_M:
    return 1;
  case MAP_FRAME1_N:
	if(!SDL_CollideBox (hero.walk[ManPos].image, x, y, cave_top,  205 + TREE_W, -15, 1, BBOX) &&
	   !SDL_CollideBox (hero.walk[ManPos].image, x, y, magenta_top,  0, 0, 1, BBOX))
      return 1;
    break;
  case MAP_FRAME1_Z:
      return 1;
    break;
  case HOUSE_FLOOR1:
    if (!SDL_CollideBox (hero.walk[ManPos].image, x, y, table1, 229, 129, 1, BBOX) &&
	!SDL_CollideBox (hero.walk[ManPos].image, x, y, merchant1, 260, 100, 1, BBOX) &&
	!SDL_CollideBox (hero.walk[ManPos].image, x, y, magenta_rec3, 405, 75, 1, BBOX)) 
      return 1;
    break;
  }
  return 0;
}

int EnemyCollision(SDL_Surface *enemy, int x, int y, int enemy_id)
{
	int i = 0, j = 0;
	extern int ActiveWorld;

	for (i = 0; i < ActiveEnemies; i++)
         {
                if (i == enemy_id)
                        continue;

                if (!monster[i].multi_directional)
                {
                        if (SDL_CollidePixel (enemy, x, y, monster[i].image,
                                    monster[i].x, monster[i].y))
                                return 1;
                }
                else
                        for (j = 0; j < monster[i].image_count; j++)
                                if (SDL_CollidePixel(enemy, x, y, monster[i].animation[j][monster[i].direction],
                                monster[i].x, monster[i].y))
                                        return 1;

                        continue;

         }
	 return 0;
}
	
int
EnemyInBounds (SDL_Surface * enemy, int x, int y, int frame, int enemy_id)
{

  int i = 0, j = 0, hit = 0;
  switch (frame) {
  case MAP_FRAME1:
    if (!SDL_CollidePixel (enemy, x, y, tree, 0, 0) &&
	!SDL_CollidePixel (enemy, x, y, lamp_grey, 130, 20) &&
        !SDL_CollidePixel (enemy, x, y, lamp_grey, 130, 180) &&
        !SDL_CollidePixel (enemy, x, y, lamp_grey, 305, 20) &&
        !SDL_CollidePixel (enemy, x, y, lamp_grey, 305, 180) &&
	!SDL_CollidePixel (enemy, x, y, house1, 400, 50))
	/* Make sure that enemies don't hit eachother */
		if(!EnemyCollision(enemy, x, y, enemy_id))
			return 1;

      return 0;
    
    break;
  case MAP_FRAME1_A:
	if (!SDL_CollidePixel (enemy, x, y, tree3, 320, 220) && 
	    !SDL_CollidePixel (enemy, x, y, tree3, 0, 0)) 
		if(!EnemyCollision(enemy, x, y, enemy_id))
                        return 1;
	return 0;
    break;
  case MAP_FRAME1_B:
    	return 1;
    break;
    /* This is the starting place (Sanctuary) */
  case MAP_FRAME1_C:
	return 1;
    break;
  case MAP_FRAME1_D:
      return 1;
    break;
  case MAP_FRAME1_L:
 	if(!EnemyCollision(enemy, x, y, enemy_id))
                        return 1;

      return 0;
    break;
  case MAP_FRAME1_Z:
	return 1;
    break;
  case HOUSE_FLOOR1:
    if (!SDL_CollidePixel (enemy, x, y, table1, 229, 129) &&
	!SDL_CollidePixel (enemy, x, y, merchant1, 260, 100))
      return 1;
    break;
  }
  return 0;
}

int
HitHouse (int x, int y, int frame)
{
	int hx, hy;

  switch (frame) {
  case MAP_FRAME1:
	if (x >= (400 + HOUSE1_DOOR_START) && x <= (400 + HOUSE1_DOOR_END))
	/* In some cases we skip more than one coordinate at a time, so we can't use an exact x or y value */
		if (y <= (50 + HOUSE1_DOOR_VERTICAL - 4))
			return 1;
    break;
  case MAP_FRAME1_B:
  	if (x >= (380 + HOUSE1_DOOR_START) && x <= (400 + HOUSE1_DOOR_END))
		if (y == (150 + HOUSE1_DOOR_VERTICAL - 4))
			return 1;
    break;
  }

  return 0;
}
