
#include "rpg.h"

/* This function determines the number of coordinates a character */
/* moves per loop cycle. Slower CPU's obviously result in less loops */
/* per usec, and therefore slower movements. We get the CPU mhz from */
/* the /proc/cpuinfo, and try to estimate the best value */

int
GetSpeedIncr (void)
{
	FILE *fd;
	unsigned int mhz;
	char buf[255], *p;
	int speedIncr;

	if ((fd = fopen ("/proc/cpuinfo", "r")) == NULL)
	{
		printf ("Error opening /proc/cpuinfo: %s\n", strerror (errno));
		return -1;
	}

	while (!feof (fd))
	{
		fgets (buf, sizeof (buf) - 1, fd);
		if (!strncasecmp (buf, "cpu mhz", 7))
		{
			p = strchr (buf, ':');
			p++;
			mhz = (unsigned int) atof (p);
			if (mhz <= 800)
				speedIncr = 6;
			else if (mhz <= 1400)
				speedIncr = 5;
			else if (mhz <= 1900)
				speedIncr = 3;
			else
				speedIncr = 1;
			break;

		}
	}
	return speedIncr;

}

int
GetAttackSpeed (void)
{
        FILE *fd;
        unsigned int mhz;
        char buf[255], *p;

        if ((fd = fopen ("/proc/cpuinfo", "r")) == NULL)
        {
                printf ("Error opening /proc/cpuinfo: %s\n", strerror (errno));
                return -1;
        }

        while (!feof (fd))
        {
                fgets (buf, sizeof (buf), fd);
                if (!strncasecmp (buf, "cpu mhz", 7))
                {
                        p = strchr (buf, ':');
                        p++;
                        mhz = (unsigned int) atof (p);
                        if (mhz <= 800)
                                return 1;
                        else if (mhz <= 1400)
                                return 2;
                        else if (mhz <= 1900)
                                return 3;
                        else
                                return 4;
                        break;

                }
        }

}

