#include "rpg.h"


void
SetEnemyCoords (struct MonstXY *monster, int playerx, int playery)
{
	int i;
	extern int xPOS, xNEG, yPOS, yNEG;
	extern int ActiveEnemies;
	extern int CPU_SPEED_VALUE;
	extern int MONSTINC;

	for (i = 0; i < ActiveEnemies; i++)
	{
		if (monster[i].status == 0)	// dead
			continue;

		/* if a monster has animation (more than one image) */
		/* then increment the 'animation modulo count' variable */
		if (monster[i].image_count)
			monster[i].amc++;

		/* Was the monster hit? (This is for non multi-directional monsters) */
		if (monster[i].hit)
		{
			monster[i].hit--;
			if (monster[i].image_count)
				monster[i].images[monster[i].image_index] = monster[i].hit_image[2];
			else
				monster[i].image = monster[i].hit_image[monster[i].hit];
			if (monster[i].hit == 0)
			{
				if (monster[i].image_count)
					monster[i].images[monster[i].image_index] = monster[i].hit_image[2];
				else
					monster[i].image = monster[i].orig_image;
			}

		}
		/* attacked is to signify that we want to show */
		/* multi-dir hit animation (animation for when the monster has */
		/* been attacked */
		if (monster[i].attacked)
		{
			if (monster[i].hit_amc++ % (monster[i].amv >> 1) == 0)
				monster[i].hit_count++;

			if (monster[i].hit_count >= (monster[i].image_count))
			{
				monster[i].hit_count = 0;
				monster[i].attacked = 0;
			}
		}

		/* Lets make sure our monsters */
		/* Are within boundaries */
		if (monster[i].y <= 0)
		{
			monster[i].direction = S;
			monster[i].LastMove = DOWN;
			monster[i].prevY = monster[i].y;
			monster[i].y += MONSTINC;
			yPOS = 0;
			yNEG = 0;
			xPOS = 0;
			xNEG = 0;
			continue;
		}
		else if (monster[i].y >= 600)
		{
			monster[i].direction = N;
			monster[i].LastMove = UP;
			monster[i].prevY = monster[i].y;
			monster[i].y -= MONSTINC;
			yPOS = 0;
			yNEG = 0;
			xPOS = 0;
			xNEG = 0;
			continue;
		}
		else if (monster[i].x <= 0)
		{
			monster[i].direction = E;
			monster[i].LastMove = RIGHT;
			monster[i].prevX = monster[i].x;
			monster[i].x += MONSTINC;
			yPOS = 0;
			yNEG = 0;
			xPOS = 0;
			xNEG = 0;
			continue;
		}
		if (monster[i].x >= 800)
		{
			monster[i].direction = W;
			monster[i].LastMove = LEFT;
			monster[i].prevX = monster[i].x;
			monster[i].x -= MONSTINC;
			yPOS = 0;
			yNEG = 0;
			xPOS = 0;
			xNEG = 0;
			continue;
		}

		if (yPOS)
		{
			monster[i].LastMove = DOWN;
			if ((monster[i].move_count++ % CPU_SPEED_VALUE) == 0)
			{
				monster[i].prevY = monster[i].y;
				
				if (monster[i].y < playery)
				{
					monster[i].y += MONSTINC;
					monster[i].direction = S;
				}
				else
				{
					monster[i].y -= MONSTINC;
					monster[i].direction = N;
				}
			}
		}
		else if (yNEG)
		{
			monster[i].LastMove = UP;
			if ((monster[i].move_count++ % CPU_SPEED_VALUE) == 0)
			{
				monster[i].prevY = monster[i].y;

				if (monster[i].y > playery)
				{
					monster[i].y -= MONSTINC;
					monster[i].direction = N;
				}
				else
				{
					monster[i].y += MONSTINC;
					monster[i].direction = S;
				}
			}
		}
		else if (xPOS)
		{
			monster[i].LastMove = RIGHT;
			if ((monster[i].move_count++ % CPU_SPEED_VALUE) == 0)
			{
				monster[i].prevX = monster[i].x;

				if (monster[i].x < playerx)
				{
					monster[i].x += MONSTINC;
					monster[i].direction = E;
				}
				else
				{
					monster[i].x -= MONSTINC;
					monster[i].direction = W;
				}
			}
		}
		else if (xNEG)
		{
			monster[i].LastMove = LEFT;
			if ((monster[i].move_count++ % CPU_SPEED_VALUE) == 0)
			{
				monster[i].prevX = monster[i].x;

				if (monster[i].x > playerx)
				{
					monster[i].x -= MONSTINC;
					monster[i].direction = W;
				}
				else
				{
					 monster[i].x += MONSTINC;
                                         monster[i].direction = E;

			 	}
			}
		}
		else
		{
			/* Save coordinates */
                        monster[i].prevY = monster[i].y;
                        monster[i].prevX = monster[i].x;

			switch (monster[i].LastMove)
			{
			case UP:
				if ((monster[i].move_count++ % CPU_SPEED_VALUE) == 0)
					monster[i].y -= MONSTINC;
				break;
			case DOWN:
				if ((monster[i].move_count++ % CPU_SPEED_VALUE) == 0)
					monster[i].y += MONSTINC;
				break;
			case RIGHT:
				if ((monster[i].move_count++ % CPU_SPEED_VALUE) == 0)
					monster[i].x += MONSTINC;
				break;
			case LEFT:
				if ((monster[i].move_count++ % CPU_SPEED_VALUE) == 0)
					monster[i].x -= MONSTINC;
			break;
			}
		}
	}       
}
