#include "rpg.h"

extern int NewFrame, current_frame_images;

extern struct MonstXY monster[255];

extern SDL_Surface *blank, *screen, *trees, *trees_right_border,
	*trees_side_border, *trees2, *trees_horizontal_border, *house1, *house2, *blue_pond,
	*floor1, *table1, *dragon_door, *statue_lake, *trees_top_border_short,
	*merchant1;
extern SDL_Surface *fog1, *fog2, *man[4];
extern player_stats stats;
extern SDL_Surface *cave_bottom, *cave_top;
extern SDL_Surface *wooden_fence_top, *palace_gate;
extern SDL_Surface *armor1, *armor2, *armor3, *green_blank,
	*wooden_fence_horizontal;
extern SDL_Surface *tombstone, *tree_rectangle, *well_of_life,
	*blank_brown_center, *round_tree;
extern SDL_Surface *garden1, *garden2;
extern SDL_Surface *tree, *tree2, *tree3, *trees_canvas;
extern SDL_Surface *lamp_grey, *lamp_base, *lamp_shadow;
extern SDL_Surface *sign_shadow, *sign, *sign_base;

extern SDL_Surface *rocks1, *rock_lc, *rock_rc;

extern int MOVE_INCREMENT, MAG_SPEED;
extern int ActiveEnemies;

void
ResetCords (int *x, int *y, int StartPoint)
{
	switch (StartPoint)
	{
	case FROM_BOTTOM:
		*x = 400;
		*y = 580;
		break;
	case FROM_TOP:
		*x = 400;
		*y = 5;
		break;
	case FROM_RIGHT:
		*x = 795;
		*y = 300;
		break;
	case FROM_LEFT:
		*x = 5;
		*y = 300; 
		break;
	}
}

void
UnloadImages (int ActiveFrame)
{
	int i, j, k;

	/* Unload Monster images */
	
	for (i = 0; i < ActiveEnemies; i++)
	{
		SDL_FreeSurface(monster[i].image);
		if (monster[i].image_count)
		{
			if (monster[i].multi_directional)
			{
				for (j = 0; j < 4; j++)
					for (k = 0; k < monster[i].image_count; k++)
						SDL_FreeSurface(monster[i].animation[j][k]);
			}
			/* monster[i].images is free'd in main() */
			monster[i].image_count = 0;
		}
	}
	
	switch (ActiveFrame)
	{
	case MAP_FRAME1:
		SDL_FreeSurface (lamp_base);
		SDL_FreeSurface (lamp_grey);
		SDL_FreeSurface (lamp_shadow);
		SDL_FreeSurface (sign_shadow);
		SDL_FreeSurface (sign_base);
		SDL_FreeSurface (sign);
		SDL_FreeSurface (garden1);
		SDL_FreeSurface (house1);
		SDL_FreeSurface (tree);
		break;
	case MAP_FRAME1_A:
		SDL_FreeSurface (tree3);
		break;
	case MAP_FRAME1_B:
		SDL_FreeSurface (tree);
		SDL_FreeSurface (house1);
		SDL_FreeSurface (house2);
		break;
	case MAP_FRAME1_C:
		SDL_FreeSurface (trees_canvas);
		SDL_FreeSurface (blue_pond);
		SDL_FreeSurface (fog1);
		SDL_FreeSurface (fog2);
		break;
	case MAP_FRAME1_D:
		SDL_FreeSurface (tree);
		break;
	case MAP_FRAME1_E:
		break;
	case MAP_FRAME1_F:
		break;
	case MAP_FRAME1_G:
		break;
	case MAP_FRAME1_H:
		break;
	case MAP_FRAME1_I:
		break;
	case MAP_FRAME1_J:
		break;
	case MAP_FRAME1_K:
		break;
	case MAP_FRAME1_L:
		break;
	case MAP_FRAME1_M:
		break;
	case MAP_FRAME1_N:
		SDL_FreeSurface (trees);
		SDL_FreeSurface (rocks1);
		SDL_FreeSurface (rock_rc);
		SDL_FreeSurface (rock_lc);
		SDL_FreeSurface (blue_pond);
		SDL_FreeSurface (cave_top);
		break;
	case MAP_FRAME1_Z:
		SDL_FreeSurface (palace_gate);
		SDL_FreeSurface (tombstone);
		SDL_FreeSurface (wooden_fence_horizontal);
		break;

	}
}


int
WhichFrame (int ActiveFrame, int *x, int *y)
{
	switch (ActiveFrame)
	{
	case MAP_FRAME1:
		if (*y <= 0)
		{
			current_frame_images = 0;
			NewFrame = 1;
			UnloadImages (ActiveFrame);
			ResetCords (x, y, FROM_BOTTOM);
			return MAP_FRAME1_A;
		}
		else if (*y >= SCREEN_H)
		{
			current_frame_images = 0;
			NewFrame = 1;
			UnloadImages (ActiveFrame);
			ResetCords (x, y, FROM_TOP);
			return MAP_FRAME1_C;
		}
		else if (*x <= 0)
		{
			current_frame_images = 0;
			NewFrame = 1;
			UnloadImages (ActiveFrame);
			ResetCords (x, y, FROM_RIGHT);
			return MAP_FRAME1_D;
		}
		else if (*x >= SCREEN_W)
		{
			current_frame_images = 0;
			NewFrame = 1;
			UnloadImages (ActiveFrame);
			ResetCords (x, y, FROM_LEFT);
			return MAP_FRAME1_B;
		}
		break;

	case MAP_FRAME1_A:
		if (*y >= SCREEN_H)
		{
			current_frame_images = 0;
			NewFrame = 1;
			UnloadImages (ActiveFrame);
			ResetCords (x, y, FROM_TOP);
			return MAP_FRAME1;
		}
		else if (*y <= 0)
		{
			current_frame_images = 0;
			NewFrame = 1;
			UnloadImages (ActiveFrame);
			ResetCords (x, y, FROM_BOTTOM);
			return MAP_FRAME1_L;
		}
		else if (*x <= 0)
		{
			current_frame_images = 0;
			NewFrame = 1;
			UnloadImages (ActiveFrame);
			ResetCords (x, y, FROM_RIGHT);
			return MAP_FRAME1_F;
		}
		else if (*x >= SCREEN_W)
		{
			current_frame_images = 0;
			NewFrame = 1;
			UnloadImages (ActiveFrame);
			ResetCords (x, y, FROM_LEFT);
			return MAP_FRAME1_E;
		}
		break;
	case MAP_FRAME1_B:
		if (*x <= 0)
		{
			current_frame_images = 0;
			NewFrame = 1;
			UnloadImages (ActiveFrame);
			ResetCords (x, y, FROM_RIGHT);
			return MAP_FRAME1;
		}
		break;
	case MAP_FRAME1_C:
		if (*y <= 0)
		{
			MAG_SPEED--;
			MOVE_INCREMENT--;
			current_frame_images = 0;
			NewFrame = 1;
			UnloadImages (ActiveFrame);
			ResetCords (x, y, FROM_BOTTOM);
			return MAP_FRAME1;
		}
		else if (*y >= SCREEN_H)
		{
			current_frame_images = 0;
			NewFrame = 1;
			UnloadImages (ActiveFrame);
			ResetCords (x, y, FROM_TOP);
			return MAP_FRAME1_H;
		}
		else if (*x <= 0)
		{
			current_frame_images = 0;
			NewFrame = 1;
			UnloadImages (ActiveFrame);
			ResetCords (x, y, FROM_RIGHT);
			return MAP_FRAME1_I;
		}
		else if (*x >= SCREEN_W)
		{
			current_frame_images = 0;
			NewFrame = 1;
			UnloadImages (ActiveFrame);
			ResetCords (x, y, FROM_LEFT);
			return MAP_FRAME1_J;
		}
	case MAP_FRAME1_D:
		if (*x >= SCREEN_W)
		{
			current_frame_images = 0;
			NewFrame = 1;
			UnloadImages (ActiveFrame);
			ResetCords (x, y, FROM_LEFT);
			return MAP_FRAME1;
		}
		break;
	case MAP_FRAME1_E:
		if (*x <= 0)
		{
			current_frame_images = 0;
			NewFrame = 1;
			UnloadImages (ActiveFrame);
			ResetCords (x, y, FROM_RIGHT);
			return MAP_FRAME1_A;
		}
		else if (*x >= SCREEN_W)
		{
			current_frame_images = 0;
			NewFrame = 1;
			UnloadImages (ActiveFrame);
			ResetCords (x, y, FROM_LEFT);
			return MAP_FRAME1_Z;
		}
		break;
	case MAP_FRAME1_F:
		if (*x >= SCREEN_W)
		{

			current_frame_images = 0;
			NewFrame = 1;
			UnloadImages (ActiveFrame);
			ResetCords (x, y, FROM_LEFT);
			return MAP_FRAME1_A;
		}
		else if (*x <= 0)
		{
			current_frame_images = 0;
			NewFrame = 1;
			UnloadImages (ActiveFrame);
			ResetCords (x, y, FROM_RIGHT);
			return MAP_FRAME1_G;
		}
		break;
	case MAP_FRAME1_L:
		if (*x <= 0)
		{
			current_frame_images = 0;
			NewFrame = 1;
			UnloadImages (ActiveFrame);
			ResetCords (x, y, FROM_RIGHT);
			return MAP_FRAME1_M;
		}
		else if (*x >= SCREEN_W)
		{
			current_frame_images = 0;
			NewFrame = 1;
			UnloadImages (ActiveFrame);
			ResetCords (x, y, FROM_LEFT);
			return MAP_FRAME1_N;
		}
		else if (*y <= 0)
		{
			current_frame_images = 0;
			NewFrame = 1;
			UnloadImages (ActiveFrame);
			ResetCords (x, y, FROM_BOTTOM);
			return MAP_FRAME1_K;
		}
		else if (*y >= SCREEN_H)
		{
			current_frame_images = 0;
			NewFrame = 1;
			UnloadImages (ActiveFrame);
			ResetCords (x, y, FROM_TOP);
			return MAP_FRAME1_A;
		}
		break;
	case MAP_FRAME1_M:
		if (*x >= SCREEN_W)
		{
			current_frame_images = 0;
			NewFrame = 1;
			UnloadImages (ActiveFrame);
			ResetCords (x, y, FROM_LEFT);
			return MAP_FRAME1_L;
		}
		break;
	case MAP_FRAME1_N:
		if (*x <= 0)
		{
			current_frame_images = 0;
			NewFrame = 1;
			UnloadImages (ActiveFrame);
			ResetCords (x, y, FROM_RIGHT);
			return MAP_FRAME1_L;
		}
		else if (*x >= SCREEN_W)
		{
			current_frame_images = 0;
			NewFrame = 1;
			UnloadImages (ActiveFrame);
			ResetCords (x, y, FROM_LEFT);
			return MAP_FRAME1_O;
		}
		else if (*y <= 0)
		{
			current_frame_images = 0;
			NewFrame = 1;
			UnloadImages (ActiveFrame);
			ResetCords (x, y, FROM_BOTTOM);
			return MAP_FRAME1_T;
		}
		else if (*y >= SCREEN_H)
		{
			current_frame_images = 0;
			NewFrame = 1;
			UnloadImages (ActiveFrame);
			ResetCords (x, y, FROM_TOP);
			return MAP_FRAME1_E;
		}
		break;
		/* Yes, Z is connected to E... don't ask */
	case MAP_FRAME1_Z:
		if (*x <= 0)
		{
			current_frame_images = 0;
			NewFrame = 1;
			UnloadImages (ActiveFrame);
			ResetCords (x, y, FROM_RIGHT);
			return MAP_FRAME1_E;
		}
		break;
	}

	/* If we get here, then stay in present frame */
	return ActiveFrame;
}
