/* landscape.c
 * This piece of source code is a part of the RPG src code
 * In landscape.c we draw the landscape for each map frame 
 * and the new philosophy is to load each image on the fly
 * so that we don't have 100 images in memory that aren't being used
 */

#include "rpg.h"

extern SDL_Surface *blank, *blank_grass1, *blank_grass1, *blank_grass2, *dirt_path, *screen;
extern SDL_Surface *house1, *house2, *house3;
extern SDL_Surface *blue_pond, *tree, *tree2;
extern SDL_Surface *floor1, *table1, *merchant1;
extern SDL_Surface *fog1, *fog2, *man[9], *wooden_fence_top;
extern player_stats stats;

extern SDL_Surface *cave_top, *armor1,
	*palace_gate;

extern SDL_Surface *green_blank, *wooden_fence_horizontal;

extern SDL_Surface *tombstone;

extern SDL_Surface *garden1, *garden2;
extern SDL_Surface *rocks1, *rock_lc, *rock_rc;

extern SDL_Surface *sign, *sign_base, *sign_shadow;
extern SDL_Surface *lamp_grey, *lamp_base, *lamp_shadow;
extern SDL_Surface *shelf, *shelf2;
extern SDL_Surface *house2, *house3, *pub, *chapel;
extern TTF_Font *stats_font;
extern SDL_Surface *magic_sign;

SDL_Surface *ParticleDot, *ParticleDotBlue, *ParticleDotRed;

extern struct Particles particle[10000];
SDL_Surface *ParticlePtr[3];

extern SDL_Surface *magenta_rec;
extern SDL_Surface *tree2, *tree3, *tree4, *trees_canvas;

extern SDL_Surface *magic_sign, *couch_diag;

extern int ActiveEnemies;
extern struct MonstXY monster[255];
extern struct NPC npc[255];

static int fog_alpha_count = 0;
static int alpha = SDL_ALPHA_TRANSPARENT;

extern SDL_Surface *magic_image[0xf], *well_of_life;
extern int UseMagic;
extern struct inventory inventory;

uint32_t fog_count = 0;
int fx = 0, fy = 0;

int global_particle_time = 0;
extern int MOVE_INCREMENT, MAG_SPEED;
extern int ManPos, global_x, global_y, magX, magY;
extern int monster_x, monster_y;
extern int draw_explosion;
extern int current_frame_images;
extern int NewFrame;
extern int step;
extern int tmpX, tmpY;
extern struct hero hero;
/* Lamp to shadow offset */

/* These functions return the offsets of where the shadows */
/* of the lamp should be */
int L2SO_X(int x)
{
	return (x + 15);
}

int L2SO_Y(int y)
{
	return (y + 25);
}
	
/* Lamp to lamp base offset */
int L2BO_X(int x)
{
	return (x + 2);
}

int L2BO_Y(int y)
{
	return (y + 75);
}

/* Tree to magenta rectangle offset */ 
int T2RO_X(int x)
{
	return (x + 35);
}

int T2RO_Y(int y)
{
	return (y + 54);
}

/* Sign to shadow offset and sign 2 base offset */
int S2SO_X(int x)
{
	return (x + 28);
}

int S2SO_Y(int y)
{
	return (y + 50);
}

int S2BO_X(int x)
{
	return (x + 21);
}

int S2BO_Y(int y)
{
	return (y + 65);
}

/* Currently the map is hardcoded in C */
/* perhaps in the future this will be changed */

/* THIS CODE IS FUCKING MESSY, NO WAY AROUND IT FOR NOW! */
/* All images are loaded on the fly, its what I like to call */
/* resource management! */
void
DrawWorld (int frame)
{
	int i, c = 0;
	char FirstTime = 1, inc_value = 1;
	int x = global_x, y = global_y;

	switch (frame)
	{
	case MAP_FRAME1:


		if (NewFrame == 1)
			if (current_frame_images != ALREADY_LOADED)
			{
				tree = LoadImage ("bmp/landscape/tree1.bmp");
				house1 = LoadImage ("bmp/town/house1.bmp");
				lamp_grey = LoadImage ("bmp/town/lamp_grey.bmp");
				lamp_base = LoadImage ("bmp/town/lamp_base.bmp");
				lamp_shadow = LoadImage ("bmp/town/lamp_shadow.bmp");
				garden1 = LoadImage("bmp/town/garden1.bmp");
				magic_sign = LoadImage("bmp/town/magic_sign.bmp");
				sign = LoadImage("bmp/town/sign.bmp");
				sign_base = LoadImage("bmp/town/sign_base.bmp");
				sign_shadow = LoadImage("bmp/town/sign_shadow.bmp");
				current_frame_images = ALREADY_LOADED;
				NewFrame = 0;
			}

		drawSprite (blank_grass1, screen, 0, 0, 0, 0, 640, 480);
		drawSprite (dirt_path, screen, 0, 0, 140, 0, 190, 349);
		

		/* All shadows should be drawn before the man (player) */
		
		drawSprite (lamp_shadow, screen, 0, 0, L2SO_X(130), L2SO_Y(60), 23, 51);
		drawSprite (lamp_shadow, screen, 0, 0, L2SO_X(130), L2SO_Y(220), 23, 51);
		drawSprite (lamp_shadow, screen, 0, 0, L2SO_X(305), L2SO_Y(60), 23, 51);
		drawSprite (lamp_shadow, screen, 0, 0, L2SO_X(305), L2SO_Y(220), 23, 51);

		drawSprite (sign_shadow, screen, 0, 0, S2SO_X(700), S2SO_Y(300), SIGN_SHADOW_W, SIGN_SHADOW_H);

		drawSprite (house1, screen, 0, 0, 400, 50, HOUSE1_W, HOUSE1_H);
                drawSprite (garden1, screen, 0, 0, 620, 50, GARDEN_W, GARDEN_H);
                drawSprite (garden1, screen, 0, 0, 620, 50 + GARDEN_H, GARDEN_W, GARDEN_H);
	
		drawSprite (magic_sign, screen, 0, 0, 400, 50 + HOUSE1_H, MAGIC_SIGN_W, MAGIC_SIGN_H);
		/* Need to draw man from here so that lamp can draw over it */
		/*
		if (hero.attacking)
			drawSprite(hero.attack[ManPos].image[step], screen, 0, 0, tmpX, tmpY, hero.attack[ManPos].sz[step].w, hero.attack[ManPos].sz[step].h);
		else
			drawSprite(hero.walk[ManPos].image[step], screen, 0, 0, x, y, hero.walk[ManPos].sz[step].w, hero.walk[ManPos].sz[step].h);
		*/

		DrawHero(&hero);
		drawSprite (lamp_grey, screen, 0, 0, 130, 60, 24, 96);
		drawSprite (lamp_grey, screen, 0, 0, 130, 220, 24, 96);
		drawSprite (lamp_grey, screen, 0, 0, 305, 60, 24, 96);
		drawSprite (lamp_grey, screen, 0, 0, 305, 220, 24, 96);
		
		drawSprite (lamp_base, screen, 0, 0, L2BO_X(130), L2BO_Y(60), 20, 20);
                drawSprite (lamp_base, screen, 0, 0, L2BO_X(130), L2BO_Y(220), 20, 20);
                drawSprite (lamp_base, screen, 0, 0, L2BO_X(305), L2BO_Y(60), 20, 20);
                drawSprite (lamp_base, screen, 0, 0, L2BO_X(305), L2BO_Y(220), 20, 20);
		
		drawSprite (tree, screen, 0, 0, 0, 0, TREE_W, TREE_H);
		drawSprite (tree, screen, 0, 0, 700, 400, TREE_W, TREE_H); 
		//drawSprite (magenta_rec, screen, 0, 0, T2RO_X(0), T2RO_Y(0), 23, 54);
		drawSprite (sign, screen, 0, 0, 700, 300, SIGN_W, SIGN_H);
		drawSprite (sign_base, screen, 0, 0, S2BO_X(700), S2BO_Y(300), SIGN_BASE_W, SIGN_BASE_H);
		/* The trees2 image should only be used as a left border */
		break;

	case MAP_FRAME1_A:
		if (NewFrame == 1)
			if (current_frame_images != ALREADY_LOADED)
			{
				tree3 = LoadImage ("bmp/landscape/tree_grass2.bmp");
				house3 = LoadImage ("bmp/town/house3.bmp");
				current_frame_images = ALREADY_LOADED;
				NewFrame = 0;
			}

		drawSprite (blank_grass2, screen, 0, 0, 0, 0, 640, 480);
		//DrawHero(&hero);
		drawSprite (tree3, screen, 0, 0, 320, 220, tree3->w, tree3->h);
		drawSprite (tree3, screen, 0, 0, 0, 0,  tree3->w, tree3->h);
		DrawHero (&hero);
		break;
	case MAP_FRAME1_C:

		/* FOG IS PRESENT */

		if (NewFrame == 1)
			if (current_frame_images != ALREADY_LOADED)
			{
				MOVE_INCREMENT++;
				MAG_SPEED += 2;
				trees_canvas = LoadImage ("bmp/landscape/trees_canvas1.bmp");
				blue_pond = LoadImage("bmp/landscape/blue_pond.bmp");
				fog1 = LoadAlphaImage ("bmp/landscape/fog.png");
				fog2 = LoadAlphaImage ("bmp/landscape/fog2.png");
				current_frame_images = ALREADY_LOADED;
				NewFrame = 0;
			}

		/* Fog Move Down */
		if (fx == 640 || fy == 480)
			inc_value = -1;
		else
			/* Fog Move up */
		if (fx == 0 || fy == 0)
			inc_value = 1;

		if ((fog_count++ % 25) == 0)
		{
			fx += inc_value;
			fy += inc_value;
		}
		/* --- SANCTUARY (STARTING POINT) --- */
	 	drawSprite(blue_pond, screen, 0, 0, 300, 350, 196, 157);
		drawSprite(trees_canvas, screen, 0, 0, 0, 0, 800, 600);
		SDL_SetAlpha (fog2, SDL_SRCALPHA, alpha + 50);
		SDL_SetAlpha (fog1, SDL_SRCALPHA, alpha + 30);

		/* In scenes with fog, we must SDL_flip twice; once in here */
		/* and once in the main loop, otherwise the fog doesn't move */
		/* unless the character is moving... this can slow things down :( */

		if (hero.attacking)
			 drawSprite(hero.attack[ManPos].image[step], screen, 0, 0, tmpX, tmpY, hero.attack[ManPos].sz[step].w, hero.attack[ManPos].sz[step].h);
		else
			drawSprite(hero.walk[ManPos].image[step], screen, 0, 0, x, y, hero.walk[ManPos].sz[step].w, hero.walk[ManPos].sz[step].h);

		drawSprite (fog1, screen, 0, 0, fx, fy, 128, 113);
		drawSprite (fog2, screen, 0, 0, fx, fy, 128, 113);

		/* We only draw man and stats from DrawWorld if there is moving fog */
		DisplayStats (stats_font, stats, screen);
		if (UseMagic)
			drawSprite (magic_image[inventory.ActiveSpell.id],
			  	    screen, 0, 0, magX, magY, FLAME_W, FLAME_H);

		SDL_Flip (screen);
		break;
	case MAP_FRAME1_B:

		if (NewFrame == 1)
			if (current_frame_images != ALREADY_LOADED)
			{

				tree = LoadImage ("bmp/landscape/tree1.bmp");
				house1 = LoadImage ("bmp/town/house1.bmp");
				house2 = LoadImage ("bmp/town/house2.bmp");
				current_frame_images = ALREADY_LOADED;
				NewFrame = 0;

			}

		drawSprite (blank_grass1, screen, 0, 0, 0, 0, 640, 480);
		drawSprite (house1, screen, 0, 0, 380, 150, HOUSE1_W, HOUSE1_H);
		drawSprite (house2, screen, 0, 0, 100, 55, HOUSE2_W, HOUSE2_H);
		
		if (hero.attacking)
			 drawSprite(hero.attack[ManPos].image[step], screen, 0, 0, tmpX, tmpY, hero.attack[ManPos].sz[step].w, hero.attack[ManPos].sz[step].h);
		else
			drawSprite(hero.walk[ManPos].image[step], screen, 0, 0, x, y, hero.walk[ManPos].sz[step].w, hero.walk[ManPos].sz[step].h);

		drawSprite (tree, screen, 0, 0, 200, 235, 43, 60);
		drawSprite (tree, screen, 0, 0, 415, 40, 43, 60);

		break;
	case MAP_FRAME1_D:


		if (NewFrame == 1)
			if (current_frame_images != ALREADY_LOADED)
			{

				tree = LoadImage ("bmp/landscape/tree1.bmp");
				current_frame_images = ALREADY_LOADED;
				NewFrame = 0;

			}
		if (hero.attacking)
			 drawSprite(hero.attack[ManPos].image[step], screen, 0, 0, tmpX, tmpY, hero.attack[ManPos].sz[step].w, hero.attack[ManPos].sz[step].h);
		else
			drawSprite(hero.walk[ManPos].image[step], screen, 0, 0, x, y, hero.walk[ManPos].sz[step].w, hero.walk[ManPos].sz[step].h);

		break;
	case MAP_FRAME1_E:

		if (NewFrame == 1)
			if (current_frame_images != ALREADY_LOADED)
			{
				current_frame_images = ALREADY_LOADED;
				NewFrame = 0;
			}

		drawSprite (blank_grass1, screen, 0, 0, 0, 0, 640, 480);
		
		if (hero.attacking)
			 drawSprite(hero.attack[ManPos].image[step], screen, 0, 0, tmpX, tmpY, hero.attack[ManPos].sz[step].w, hero.attack[ManPos].sz[step].h);
		else
			drawSprite(hero.walk[ManPos].image[step], screen, 0, 0, x, y, hero.walk[ManPos].sz[step].w, hero.walk[ManPos].sz[step].h);

		break;
	case MAP_FRAME1_F:
		if (NewFrame == 1)
			if (current_frame_images != ALREADY_LOADED)
			{
				current_frame_images = ALREADY_LOADED;
				NewFrame = 0;
			}
		
		if (hero.attacking)
                         drawSprite(hero.attack[ManPos].image[step], screen, 0, 0, tmpX, tmpY, hero.attack[ManPos].sz[step].w, hero.attack[ManPos].sz[step].h);
                else
			drawSprite(hero.walk[ManPos].image[step], screen, 0, 0, x, y, hero.walk[ManPos].sz[step].w, hero.walk[ManPos].sz[step].h);

		break;
	case MAP_FRAME1_G:
		drawSprite (blank_grass1, screen, 0, 0, 0, 0, 640, 480);
		
		if (hero.attacking)
                         drawSprite(hero.attack[ManPos].image[step], screen, 0, 0, tmpX, tmpY, hero.attack[ManPos].sz[step].w, hero.attack[ManPos].sz[step].h);
                else
			drawSprite(hero.walk[ManPos].image[step], screen, 0, 0, x, y, hero.walk[ManPos].sz[step].w, hero.walk[ManPos].sz[step].h);

		break;
	case MAP_FRAME1_H:
		drawSprite (blank_grass1, screen, 0, 0, 0, 0, 640, 480);
		
		if (hero.attacking)
                         drawSprite(hero.attack[ManPos].image[step], screen, 0, 0, tmpX, tmpY, hero.attack[ManPos].sz[step].w, hero.attack[ManPos].sz[step].h);
                else
			drawSprite(hero.walk[ManPos].image[step], screen, 0, 0, x, y, hero.walk[ManPos].sz[step].w, hero.walk[ManPos].sz[step].h);

		break;
	case MAP_FRAME1_I:
		drawSprite (blank_grass1, screen, 0, 0, 0, 0, 640, 480);
	
		if (hero.attacking)
                         drawSprite(hero.attack[ManPos].image[step], screen, 0, 0, tmpX, tmpY, hero.attack[ManPos].sz[step].w, hero.attack[ManPos].sz[step].h);
                else
			drawSprite(hero.walk[ManPos].image[step], screen, 0, 0, x, y, hero.walk[ManPos].sz[step].w, hero.walk[ManPos].sz[step].h);

		break;
	case MAP_FRAME1_J:
		drawSprite (blank_grass1, screen, 0, 0, 0, 0, 640, 480);
		if (hero.attacking)
                         drawSprite(hero.attack[ManPos].image[step], screen, 0, 0, tmpX, tmpY, hero.attack[ManPos].sz[step].w, hero.attack[ManPos].sz[step].h);
                else
			drawSprite(hero.walk[ManPos].image[step], screen, 0, 0, x, y, hero.walk[ManPos].sz[step].w, hero.walk[ManPos].sz[step].h);

		break;
	case MAP_FRAME1_K:
		drawSprite (blank_grass1, screen, 0, 0, 0, 0, 640, 480);
		if (hero.attacking)
                         drawSprite(hero.attack[ManPos].image[step], screen, 0, 0, tmpX, tmpY, hero.attack[ManPos].sz[step].w, hero.attack[ManPos].sz[step].h);
                else
			drawSprite(hero.walk[ManPos].image[step], screen, 0, 0, x, y, hero.walk[ManPos].sz[step].w, hero.walk[ManPos].sz[step].h);

		break;
	case MAP_FRAME1_L:

		if (NewFrame == 1)
			if (current_frame_images != ALREADY_LOADED)
			{
				current_frame_images = ALREADY_LOADED;
				NewFrame = 0;
			}

		drawSprite (blank_grass1, screen, 0, 0, 0, 0, 640, 480);
		
		if (hero.attacking)
                         drawSprite(hero.attack[ManPos].image[step], screen, 0, 0, tmpX, tmpY, hero.attack[ManPos].sz[step].w, hero.attack[ManPos].sz[step].h);
                else
			drawSprite(hero.walk[ManPos].image[step], screen, 0, 0, x, y, hero.walk[ManPos].sz[step].w, hero.walk[ManPos].sz[step].h);

		break;
	case MAP_FRAME1_M:

		if (NewFrame == 1)
			if (current_frame_images != ALREADY_LOADED)
			{
				current_frame_images = ALREADY_LOADED;
				NewFrame = 0;
			}
		drawSprite (blank_grass1, screen, 0, 0, 0, 0, 640, 480);
		
		if (hero.attacking)
                         drawSprite(hero.attack[ManPos].image[step], screen, 0, 0, tmpX, tmpY, hero.attack[ManPos].sz[step].w, hero.attack[ManPos].sz[step].h);
                else
			drawSprite(hero.walk[ManPos].image[step], screen, 0, 0, x, y, hero.walk[ManPos].sz[step].w, hero.walk[ManPos].sz[step].h);

		break;
	case MAP_FRAME1_N:

		if (NewFrame == 1)
			if (current_frame_images != ALREADY_LOADED)
			{
				/* Must be alpha, they will go transparent */
				/* Once the the de-materialize spell is active */
				rocks1 = LoadImage ("bmp/landscape/rockery1.bmp");
				rock_lc = LoadImage("bmp/landscape/rock_left_corner.bmp");
				rock_rc = LoadImage ("bmp/landscape/rock_right_corner.bmp");
				tree = LoadImage ("bmp/landscape/tree1.bmp");
				cave_top = LoadImage ("bmp/landscape/cave_top.bmp");
				blue_pond = LoadImage ("bmp/landscape/blue_pond.bmp");
				current_frame_images = ALREADY_LOADED;
				NewFrame = 0;
			}
		drawSprite (blank_grass1, screen, 0, 0, 0, 0, 640, 480);
		drawSprite (rock_lc, screen, 0, 0, 0, 0, ROCK_LC_W, ROCK_LC_H);
		drawSprite (rock_rc, screen, 0, 0, 800-ROCK_RC_W, 0, ROCK_RC_W, ROCK_RC_H);
		drawSprite (rocks1, screen, 0, 0, ROCK_LC_W, 0, ROCKERY1_W, ROCKERY1_H);
		drawSprite (rocks1, screen, 0, 0, ROCK_LC_W+ROCKERY1_W, 0, ROCKERY1_W, ROCKERY1_H);
		drawSprite (rocks1, screen, 0, 0, ROCK_LC_W+ROCKERY1_W*2, 0, ROCKERY1_W, ROCKERY1_H);
		drawSprite (rocks1, screen, 0, 0, 200, 0, ROCKERY1_W, ROCKERY1_H);
		drawSprite (rocks1, screen, 0, 0, 200+ROCKERY1_W, 0, ROCKERY1_W, ROCKERY1_H);
		drawSprite (rocks1, screen, 0, 0, 200+ROCKERY1_W*2, 0, ROCKERY1_W, ROCKERY1_H);
 		drawSprite (rocks1, screen, 0, 0, 200+ROCKERY1_W*3, 0, ROCKERY1_W, ROCKERY1_H);
		drawSprite (rocks1, screen, 0, 0, 200+ROCKERY1_W*4, 0, ROCKERY1_W, ROCKERY1_H);
		drawSprite (rocks1, screen, 0, 0, 200+ROCKERY1_W*5, 0, ROCKERY1_W, ROCKERY1_H);
	 	drawSprite (rocks1, screen, 0, 0, 200+ROCKERY1_W*6, 0, ROCKERY1_W, ROCKERY1_H);
		drawSprite (rocks1, screen, 0, 0, 200+ROCKERY1_W*7, 0, ROCKERY1_W, ROCKERY1_H);
		drawSprite (rocks1, screen, 0, 0, 200+ROCKERY1_W*8, 0, ROCKERY1_W, ROCKERY1_H);

		drawSprite (blue_pond, screen, 0, 0, 230, 230, 196, 157);
		
		if (hero.attacking)
                         drawSprite(hero.attack[ManPos].image[step], screen, 0, 0, tmpX, tmpY, hero.attack[ManPos].sz[step].w, hero.attack[ManPos].sz[step].h);
                else
			drawSprite(hero.walk[ManPos].image[step], screen, 0, 0, x, y, hero.walk[ManPos].sz[step].w, hero.walk[ManPos].sz[step].h);

		drawSprite (tree, screen, 0, 0, 205, 0, TREE_W, TREE_H);
		drawSprite (tree, screen, 0, 0, 415, 0, TREE_W, TREE_H);
		drawSprite (cave_top, screen, 0, 0, 205 + TREE_W, -15, MINE_W, MINE_H);
		break;
	case MAP_FRAME1_Z:
		if (NewFrame == 1)
			if (current_frame_images != ALREADY_LOADED)
			{
				tombstone = LoadImage ("bmp/landscape/tombstone.bmp");
				wooden_fence_horizontal =
					LoadImage ("bmp/landscape/wooden_fence_horizontal.bmp");
				palace_gate = LoadImage ("bmp/landscape/palace_gate.bmp");
				current_frame_images = ALREADY_LOADED;
				NewFrame = 0;
			}

		drawSprite (blank_grass1, screen, 0, 0, 0, 0, 800, 600);
		drawSprite (palace_gate, screen, 0, 0, 193, 0, 112, 61);
		drawSprite (wooden_fence_horizontal, screen, 0, 0, 40, 460, 598, 20);
		drawSprite (tombstone, screen, 0, 0, 60, 420, 34, 28);
		drawSprite (tombstone, screen, 0, 0, 115, 430, 34, 28);
		drawSprite (tombstone, screen, 0, 0, 175, 420, 34, 28);
		drawSprite (wooden_fence_horizontal, screen, 0, 0, 40, 395, 598, 20);
		
		if (hero.attacking)
                         drawSprite(hero.attack[ManPos].image[step], screen, 0, 0, tmpX, tmpY, hero.attack[ManPos].sz[step].w, hero.attack[ManPos].sz[step].h);
                else
			drawSprite(hero.walk[ManPos].image[step], screen, 0, 0, x, y, hero.walk[ManPos].sz[step].w, hero.walk[ManPos].sz[step].h);

		break;

	}


}

void draw_NPC(int ActiveNPC, int playerx, int playery, int frame)
{
	int i;
	SDL_Surface *ptr;
	extern int xPOS, xNEG, yPOS, yNEG;
	int increased_count = 0;

	for (i = 0; i < ActiveNPC; i++)
	{	
		if (npc[i].location != frame)
			continue;
		
		if (npc[i].InAction == 0)
		{
			if (yPOS)
			{
				if (npc[i].y < playery)
					npc[i].direction = S;
				else
					npc[i].direction = N;
			}
			else
			if (yNEG)
			{
				if (npc[i].y > playery)
					npc[i].direction = N;
				else
					npc[i].direction = S;
			}
			else
			if (xPOS)
			{
			 	if (npc[i].x < playerx)
                                        npc[i].direction = E;
                                else
                                        npc[i].direction = W;
			}
			else
			if (xNEG)
			{
				if (npc[i].x > playerx)
					npc[i].direction = W;
				else
					npc[i].direction = E;
			}
			drawSprite(npc[i].image[npc[i].direction][0], screen, 0, 0, npc[i].x, npc[i].y, 
			npc[i].size[npc[i].direction].w, npc[i].size[npc[i].direction].h);
			continue;
		}
		else
                {
                        if (yPOS)
                        {
                                if (npc[i].y < playery)
                                        npc[i].direction = S;
                                else
                                        npc[i].direction = N;
                        }
                        else
                        if (yNEG)
                        {
                                if (npc[i].y > playery)
                                        npc[i].direction = N;
                                else
                                        npc[i].direction = S;
                        }
                        else
                        if (xPOS)
                        {
                                if (npc[i].x < playerx)
                                        npc[i].direction = E;
                                else
                                        npc[i].direction = W;
                        }
                        else
                        if (xNEG)
                        {
                                if (npc[i].x > playerx)
                                        npc[i].direction = W;
                                else
                                        npc[i].direction = E;
                        }

			if (npc[i].count >= npc[i].talk_images - 1)
				npc[i].count = 0;

                        drawSprite(npc[i].image[npc[i].direction][npc[i].count], screen, 0, 0, npc[i].x, npc[i].y,
                        npc[i].size[npc[i].direction].w, npc[i].size[npc[i].direction].h);
			
			if ((npc[i].amc++ % npc[i].amv) == 0)
                        {
                                npc[i].count++;
                                increased_count = 1;
                        }

			if (increased_count == 1)
			{
				SDL_Flip(screen);
				increased_count ^= increased_count;
			}
                        continue;
                }

		
		if ((npc[i].amc++ % npc[i].amv) == 0);
	}
}
			
void init_NPC(int frame, struct dialog_info *dialogs)
{
	int i;

	for (i = 0; i < 32; i++)
	{
		npc[i].amc = 0;
		npc[i].amv = 40;
		dialogs[i].index = 0;
	}

	switch (frame)
	{
		case MAP_FRAME1_B:
	
#ifdef DEBUG
		printf("Initiating NPC's\n");
#endif
		if (parse_dynamic_data(NULL, npc, &inventory, dialogs, MAP_FRAME1_B) == -1)
                {
                        printf("Failed in loading enemy content\n");
                        do_panic();
                }
		break;
	}
}
			
void
init_monsters (int frame)
{
	int i;
	ActiveEnemies = 0;
	
	for (i = 0; i < 32; i++)
	{
		monster[i].hit = 0;
		monster[i].hit_count = 0;
		monster[i].attacked = 0;
		monster[i].image_count = 0;
		monster[i].multi_directional = 0;
		monster[i].move_count = 0;
		monster[i].status = 0;
	}

	switch (frame)
	{
	case MAP_FRAME1:
		if (parse_dynamic_data(monster, NULL, NULL, NULL, MAP_FRAME1) == -1)
                {
                        printf("Failed in loading enemy content\n");
                        do_panic();
                }
		break;
	case MAP_FRAME1_A:
		if (parse_dynamic_data(monster, NULL, NULL, NULL, MAP_FRAME1_A) == -1)
                {
                        printf("Failed in loading enemy content\n");
                        do_panic();
                }
		break;
	case MAP_FRAME1_B:
		/*
		if (parse_dynamic_data(monster, NULL, NULL, MAP_FRAME1_B) == -1)
                {
                        printf("Failed in loading enemy content\n");
                        do_panic();
                }
		*/
		break;
		/* HOME TOWN */
	case MAP_FRAME1_C:
		ActiveEnemies = 0;
		break;
	case MAP_FRAME1_D:
		break;
	case MAP_FRAME1_L:
		break;

	}
}

void UnloadHouse(void)
{
	SDL_FreeSurface(floor1);
	SDL_FreeSurface(table1);
	SDL_FreeSurface(merchant1);
	SDL_FreeSurface(shelf);
	SDL_FreeSurface(couch_diag);
}

/* Draws the inside of a house */
void
DrawHouse (void)
{
	int x = global_x, y = global_y;

	if (NewFrame == 1)
		if (current_frame_images != ALREADY_LOADED)
		{
			floor1 = LoadImage ("bmp/house/floor1.bmp");
			table1 = LoadImage ("bmp/house/table1.bmp");
			merchant1 = LoadImage ("bmp/house/merchant1.bmp");
			shelf = LoadImage ("bmp/house/shelf1.bmp");
			couch_diag = LoadImage("bmp/house/couch_diagnol.bmp");
			current_frame_images = ALREADY_LOADED;
			NewFrame = 0;
		}
	
	drawSprite (floor1, screen, 0, 0, 0, 0, 640, 480);
	drawSprite (table1, screen, 0, 0, 229, 129, 138, 33);
	drawSprite (merchant1, screen, 0, 0, 290, 70, 37, 58);
	drawSprite (shelf, screen, 0, 0, 400, 70, SHELF1_W, SHELF1_H);
	drawSprite (couch_diag, screen, 0, 0, 400 + SHELF1_W+10, 80, COUCH_DIAG_W, COUCH_DIAG_H);
	if (hero.attacking)
		drawSprite(hero.attack[ManPos].image[step], screen, 0, 0, tmpX, tmpY, hero.attack[ManPos].sz[step].w, hero.attack[ManPos].sz[step].h);
	else
		drawSprite (hero.walk[ManPos].image[step], screen, 0, 0, x, y, hero.walk[ManPos].sz[step].w, hero.walk[ManPos].sz[step].h);
}
