/* Original 2D graphics Engine by ElfMaster */
/* ryan@bitlackeys.com */

#include "rpg.h"

#define UP 0
#define RIGHT 2
#define DOWN 4
#define LEFT 6

#define DEFAULT_SAVE "save_data/game.0"

int GameActive = 0;

/* These are the global surfaces for the game */
/* Eventually as things become more dynamic these will probably */
/* not exist, but that is along time from now */
SDL_Surface *man[9];
SDL_Surface *sword[9];
SDL_Surface *screen;
SDL_Surface *fog1, *fog2, *tree;
SDL_Surface *cave_bottom, *cave_top, *wooden_fence_top;
SDL_Surface *palace_gate;
SDL_Surface *dirt_path, *green_blank, *blank_grass1, *blank_grass2, *wooden_fence_horizontal;
SDL_Surface *tombstone;
SDL_Surface *coin_blue, *coin_red, *coin_purple;
SDL_Surface *round_tree;
SDL_Surface *lavren;
SDL_Surface *house2, *house3, *pub, *chapel;
SDL_Surface *lamp_grey, *lamp_base;
SDL_Surface *lamp_shadow;
SDL_Surface *tree2, *tree3, *tree4, *trees_canvas;
SDL_Surface *garden1, *garden2;
SDL_Surface *sign, *sign_base, *sign_shadow;
SDL_Surface *shelf, *shelf2;
SDL_Surface *magic_sign, *couch_diag;
SDL_Surface *rocks1, *rock_lc, *rock_rc;
SDL_Surface *dialog_box;
SDL_Surface *spirit[4];

/* global liked list head */
struct quest_list *root = NULL;
struct hero hero;
int step = 1; /* Each step is a differet index into the heroes animation movement */
/* color key rectangle */
/* These should really be put into one array indexed by readable names */
SDL_Surface *magenta_rec, *magenta_rec2, *magenta_rec3, *magenta_top;

/* global variable indicating obscure inventory update thingy */
int INVENTORY_UPDATE = 0;

/* global item count */
int ITEM_COUNT = 0;

/* How many points MP replenishes (based on level) */
int MP_REPLENISH_INCR = 1;

/* loaded or unloaded */
int current_frame_images = 0;
/* signify a new map frame */
int NewFrame = 1;

uint8_t LOAD_GAME = 0;

int InHouse = 0;
int MOVE_INCREMENT; /* Speed of player movement */
int MAG_SPEED;/* Magic Speed */
int MONSTINC; /*Monster speed */

int CPU_SPEED_VALUE; /* Either 1 or 2 to run a modulus op on */
/* Starting frames map and house */
int ActiveWorld = 0;
int ActiveHouse = HOUSE_FLOOR1;
int ActiveEnemies = 0;
int ActiveNPC = 0;

int UseMagic = 0;
//struct MonstXY MonstXY; // monster coordinates 

int LastMove = 0;
int ManPos = 0, SwordPos = 0;

int EXPLOSION_TIME = 100;

/* Did we Load a game? */
int LoadGame = 0;

int global_x, global_y;
int magX, magY;

/* global coordinates where last killed monster is located */
int monster_x, monster_y;
int draw_explosion = 0;

int global_diagnol = 0;

/* TimeVal we use for various things */
struct timeval tv;

/* SAVE GAME */
struct save_data sd;
int game_id = 0;

TTF_Font *merchant_font, *stats_font, *inventory_font, *small_font;


/* SDL_Surface *ts[50];  text surface, max words is 50 */
int current_words = 0;

struct text_surface ts[50];

uint32_t CurrentTick = 0;
uint32_t StartTick;

struct Particles particle[10000];

SDL_Surface *cursor_image, *cursor_image_selected;
	
/* Money/Coin info */
int ExistingCoins = 0;
struct coin_data 
{
	int x;
	int y;
	int status;

} coin_data[255];

/* Important globals the define the current angle of the player */
int xPOS, yPOS, xNEG, yNEG;

static void intro(void);
static void MainLoop(void);

int MP_Refill_Tick = 0;
uint8_t diagnol = 0;

/* List of all possible weapon/spell items */
struct action_item_list action_item_list;
int Moving = 0;

int MAX_SOUND_EFFECTS = 3;

SDL_AudioSpec desired, obtained;
sound_t sound_file[5];
playing_t playing[5];
struct sound_wave
{
	char file[255];
	int time;
};

/* filename and sound in seconds */
struct sound_wave sound_wave[] =  {
{"sound/got_hit.wav", 1},
{"sound/strike_sword.wav", 1},
{"sound/bg1.wav", 65} 
};

/* VITAL */
int playerx, playery;
int x, y, tmpX, tmpY;

/* FOR MULTI-PLAYER */
uint8_t server_mode = 0, client_mode = 0;
int global_sock;
unsigned long client_ip, server_ip;

void menu (void)
{
	int alpha = SDL_ALPHA_TRANSPARENT;
	int bx = 316, by = 320;
	uint8_t begin = 0, config = 0;
	
	SDLKey key;
	SDL_Surface *settings, *start, *load, *lav, *outline;
	SDL_Event event;

	lav = LoadImage("bmp/hero/lavren2.bmp");
	
	load = LoadAlphaImage("bmp/intro/load_button.png");
	start = LoadAlphaImage("bmp/intro/start_button.png");
	settings = LoadAlphaImage("bmp/intro/settings_button.png");
	outline = LoadAlphaImage("bmp/intro/button_outline.png");

	SDL_SetAlpha (outline, SDL_SRCALPHA, alpha + 75);

	UpdateMenu:

	drawSprite(lav, screen, 0, 0, 300, 100, 173, 133);
	drawSprite(start, screen, 0, 0, 300, 300, BUTTON_W, BUTTON_H);
	drawSprite(load, screen, 0, 0, 300, 375, BUTTON_W, BUTTON_H);
	drawSprite(settings, screen, 0, 0, 300, 450, BUTTON_W, BUTTON_H);
	drawSprite(outline, screen, 0, 0, bx, by, BUTTON_W+10, BUTTON_H+10);
	SDL_Flip(screen);
	/* */
	SDL_WaitEvent(&event);
        switch(event.type)
	{
		case SDL_KEYDOWN:
                	key = event.key.keysym.sym;
			switch(key)
			{
				case SDLK_UP:
					if (by == 320)
						goto UpdateMenu;
					by = by - BUTTON_H - 15;
					goto UpdateMenu;
				case SDLK_DOWN:
					if (by >= 470)
						goto UpdateMenu;
					by = by + BUTTON_H + 15;
					goto UpdateMenu;
				case SDLK_RETURN:
					if (by == 320)
						begin++;
					else
					if (by == 395)
						LOAD_GAME++;
			}
	}
	
	if (begin == 0 && LOAD_GAME == 0 && config == 0)
		goto UpdateMenu;
				 	

	SDL_FreeSurface(load);
	SDL_FreeSurface(settings);
	SDL_FreeSurface(start);
	SDL_FreeSurface(outline);

	ClearBlack(screen);
	start_game:
	return /* letz go */;
}

struct timeval fps_tv;
long fps_sec = 0;
uint8_t CHECK_FPS = 0;
int fps_val = 0;

void GET_FPS(void)
{
	fps_val++;
	if (fps_sec == 0)
	{
		gettimeofday(&fps_tv, NULL);
		fps_sec = fps_tv.tv_sec;
	}
	else
	{
		gettimeofday(&fps_tv, NULL);
		if ((fps_tv.tv_sec - fps_sec) == 1)
		{
			CHECK_FPS = 1;
			fps_sec = 0;
		}
	}

}	
		


int no_sound = 0; /* a debug option */
int main(int argc, char **argv)
{
	
	char debug = 0;
	xSDL_Init(SDL_INIT_VIDEO|SDL_INIT_AUDIO|SDL_INIT_TIMER);
	screen = xSDL_SetVideoMode(SCREEN_W, SCREEN_H, COLOR_DEPTH, /*SDL_FULLSCREEN |*/ SDL_DOUBLEBUF |  SDL_HWSURFACE | SDL_RESIZABLE);
	SDL_WM_SetCaption("Lavrens Quest", 0 );
	
	MOVE_INCREMENT = GetSpeedIncr();
	MONSTINC = (MOVE_INCREMENT > 2 ? MOVE_INCREMENT - 2 : MOVE_INCREMENT);
	MAG_SPEED = MOVE_INCREMENT + 3;
	EXPLOSION_TIME /= MOVE_INCREMENT*2; /* Either 100 (Default) or 50 for Slow CPU's */
	TTF_Font *font;
	
	hero.attack_amv = GetAttackSpeed();
	
	/* The following applies to enemy speed */
	switch(MOVE_INCREMENT)
	{
		case 4:
		case 3:			
			CPU_SPEED_VALUE = ONCE_EVERY_LOOP; /* for slow CPU */	
			break;
		case 2:
		case 1:
			CPU_SPEED_VALUE = ONCE_EVERY_2_LOOPS;
			break;
	}	
	
	LoadHero(&hero);

	if (argc > 1)
	{
		if (!strcmp(argv[1], "debug"))
		{
			debug = 1;
			goto skip_load;
		}
		
		if (!strcmp(argv[1], "debug_nosound"))
		{
			debug = 1;
			no_sound = 1;
			goto skip_load;
		}
		LoadGame = 1;
		if (load_game(argv[1], &sd) == -1)
		{
			printf("Cannot access game data, exiting.\n");
			goto clean;
		}
	}
	
	skip_load:

	if (argc > 2)
	{
		if (!strcmp(argv[2], "--be-server"))
		{
			server_mode = 1;
			global_sock = bind_connection();
		}
		else
		if (!strcmp(argv[2], "--be-client"))
		{
			
			client_mode = 1;

			if (argc < 3)
			{
				printf("--be-client requires the servers IP address\n");
				goto clean;	
			}
			
			/* use inet_aton in future (just lazy ;p ) */
			if ((server_ip = inet_addr(argv[3])) == -1)
			{
				printf("Server must be in dotted decimal IP format (not a hostname)\n");
				goto clean;
			}
			
			global_sock = ip_connect(server_ip, GAME_PORT);
			if (global_sock == -1)
			{
				printf("Failed connection to game server\n");
				goto clean;
			}

			printf("[RPG] Connection has been made to %s\n", argv[3]);
		}
		
	}	

	atexit(SDL_Quit);
	atexit(SDL_CloseAudio);
	
	desired.freq = 44100;
	desired.format = AUDIO_S16;
	desired.samples = 0x1000;
	desired.channels = 2;
	desired.callback = AudioCallback;
	desired.userdata = NULL;
	
	if (no_sound)
		/* Skip loading of sound */
		goto load_menu;
	
	if (SDL_OpenAudio(&desired, &obtained) < 0)
	{
		printf("Unable to load sound\n");
		goto clean;
	}
	
	int i;
	for (i = 0; i < MAX_SOUND_EFFECTS; i++)
	{
		if (LoadAndConvertSound(sound_wave[i].file, &obtained, &sound_file[i]) != 0)
		{
			printf("Unable to load sound\n");
			goto clean;
		}
	}
		
	
	ClearPlayingSounds();

	SDL_PauseAudio(0);

	load_menu:
	menu();
        /* for now just load save_data/game.0 */
	if (LOAD_GAME)
	{
		LoadGame = 1;
		if (load_game(DEFAULT_SAVE, &sd) == -1)
        	{
        		printf("Cannot access game data, exiting.\n");
                	goto clean;
        	}
	}

	if (TTF_Init() < 0)
	{
		printf("Unable to load TTF (Font features), exiting.\n");
		goto clean;
	}
		
  	if ((merchant_font = TTF_OpenFont(FONT, FONT_SIZE)) == NULL)
	{
		printf("Unable to load font: %s %s\n", FONT, TTF_GetError());
		goto clean;
	}

	if ((inventory_font = TTF_OpenFont(FONT2, 16)) == NULL)
        {
                printf("Unable to load font: %s %s\n", FONT2, TTF_GetError());
                goto clean;
        }

	if ((stats_font = TTF_OpenFont(STATS_FONT, 16)) == NULL)
	{
                printf("Unable to load font: %s %s\n", STATS_FONT, TTF_GetError());
                goto clean;
        }

	small_font = merchant_font;

	init_action_items(&action_item_list);
	if (LoadGame == 0 && !debug)
		intro();

	MainLoop();
	clean:
	cleanup();
}

/* magX and magY are already globals */
static void SetSpellVelocity(int *UseMagic, int *MagDir)
{

/* Set the position, angle, speed of projectile spells */
			
	int tmp = *UseMagic;

        if (*UseMagic < 2)
        {
        	magY = playery;
                magX = playerx;
        }
        
	if (magY == 0 || magY == SCREEN_H)
        	*UseMagic = 0;
        if (magX == 0 || magX == SCREEN_W)
                *UseMagic = 0;
        
	if (*UseMagic < 2)
    	    switch(ManPos)
            {
            	case UP:
                	*MagDir = UP;
                        magY -= MAG_SPEED;
                        break;
                case RIGHT:
                        *MagDir = RIGHT;
                        magX += MAG_SPEED;
                        break;
                case DOWN:
                        *MagDir = DOWN;
                        magY += MAG_SPEED;
                        break;
                case LEFT:
                        *MagDir = LEFT;
                        magX -= MAG_SPEED;
                        break;
            }
            else
            {
            	if (*MagDir == UP)
                	magY -= MAG_SPEED;
                else
                if (*MagDir == RIGHT)
                        magX += MAG_SPEED;
                else
                if (*MagDir == DOWN)
                        magY += MAG_SPEED;
                else
                if (*MagDir == LEFT)
                        magX -= MAG_SPEED;
            }

            *UseMagic = tmp + 1;

}

void ClearBlack(SDL_Surface *surface)
{
        SDL_FillRect(screen, NULL, SDL_MapRGB(screen->format, 0, 0, 0));
}

struct player_stats stats;
struct inventory inventory;
struct MonstXY monster[255];
struct NPC npc[255];

SDL_Surface *blank;
SDL_Surface *trees, *trees2, *trees3, 
*trees_right_border, *trees_side_border, *trees_horizontal_border, *trees_top_border_short;

SDL_Surface *blue_pond;
SDL_Surface *house1, *floor1, *table1;
SDL_Surface *merchant1;
SDL_Surface *inventory1, *inventory2;
SDL_Surface *magic_image[0xf];
SDL_Surface *monster1[32], *monster_hit[128];
SDL_Surface *dragon_door;
SDL_Surface *statue_lake;

SDL_Color text_fg = {0xff, 0xff, 0xff, 00};


int DrawInventory(void)
{
	drawSprite(inventory1, screen, 0, 0, 0, 0, 800, 600);
	
}

int CurrentSong;

/* Starting a new game, these are init stats */
static void init_start_stats(void)
{
	int i;

	stats.hp = START_HP;
	stats.mp = START_MP;

	stats.max_mp = START_MP;
	stats.max_hp = START_HP;

	inventory.ActiveSword.damage = START_SWORD_DAMAGE;
	inventory.ActiveSword.id = 0;

	inventory.ActiveSpell.damage = START_SPELL_DAMAGE;
	inventory.ActiveSpell.rmp = 1;
	inventory.ActiveSpell.type = FLAME_SPELL;
	
	inventory.ActiveArmor.damage_intake = 1; /* 1:1 mapping, so no protection */
	inventory.ActiveArmor.type = 1;
	
	inventory.ActiveSword.id = 0;
	inventory.ActiveSpell.id = 0;
	inventory.ActiveArmor.id = 0;
	
	stats.exp = 0;
	stats.level = 1;
	stats.gold = 0;

	/* required xp for next level, this changes of course */
	stats.NextLevel = 400;

	/* initialize the items you have */
	for (i = 0; i < MAX_ITEM; i++)
		inventory.items[i].item_id = 0;

	/* starting location of player */
	global_x = 382;
	global_y = 420;
	
	ActiveWorld = MAP_FRAME1_C;

	for (i = 0; i < 255; i++)
		coin_data[i].status = 0;

	CurrentSong = BG_MUSIC_1;
}

void IncreaseMP(uint32_t *mp_counter)
{
	if (*mp_counter >= MP_TICK_MAX)
        {
        	*mp_counter ^= *mp_counter;
                if (stats.mp < stats.max_mp)
                {
                	stats.mp += MP_REPLENISH_INCR;
                        stats.mp = (stats.mp > stats.max_mp ? stats.max_mp : stats.mp);
                }
    	}
}


static uint32_t TimeLeft(void)
{
    static uint32_t next_time = 0;
    uint32_t now;

    now = SDL_GetTicks();
    if (next_time <= now ) 
    {
        next_time = now + 13;
        return 0;
    }
    return(next_time-now);
}

int CoinColor = 0;
SDL_Surface *CoinType[3];
int AtleastOneCoinActive = 0;
int CoinCount = 0;
uint8_t UseSword = 0, UsedSword = 0, flippit = 0;

static void DrawCoins(void)
{
	int i;
	for (i = 0; i < ExistingCoins; i++)
        {
        	if (coin_data[i].status)
                {
                	drawSprite(CoinType[CoinColor], screen, 0, 0, coin_data[i].x, coin_data[i].y, 38, 59);
                        AtleastOneCoinActive = 1;
                }
        }
        if (!AtleastOneCoinActive)
        	ExistingCoins = 0;
	
	if ((CoinCount++ % 10) == 0)
       		if (++CoinColor == 3)
            		CoinColor = 0;
}

bool TouchedCoin(SDL_Surface *player, int px, int py, SDL_Surface *target, int tx, int ty)
{
	if (SDL_CollidePixel(player, px, py, target, tx, ty))
		return true;
	return false;
}

/* The following is for timing attack collisions */
struct timeval collide_tv;
int collide_time = 0;
uint8_t check_collision = 0, collided_while_attacking = 0;

int tv_sec1;

/* ENEMY LOOP MAINTAINS ENEMY ANIMATION AND */
/* ENEMY ATTACKS */
static void enemy_loop(uint8_t *check_time)
{
	SDL_Surface *temp_mimage;
	int i, j, elapsed_time;
	struct timeval tv;
	
	check_collision = 0;

	for (i = 0; i < ActiveEnemies; i++)
	{
		if (monster[i].status == 1)
		{
			if (monster[i].multi_directional)
				temp_mimage = monster[i].animation[monster[i].direction][monster[i].image_index];
			else
				temp_mimage = monster[i].image;
			
			/* HANDLE ATTACK AND COLLISION TIMING */
			if (Moving || collided_while_attacking)
			{
				if (collided_while_attacking)
				{
					gettimeofday(&collide_tv, NULL);
					if ((collide_tv.tv_sec - collide_time) == 1)
					{
						check_collision++;
						collided_while_attacking = 0;
					}
						
				}
				else
				{
					gettimeofday(&collide_tv, NULL);
					collide_time = collide_tv.tv_sec;
					collided_while_attacking++;
				}
			}
				
			/* HANDLE COLLISION AND COLLISION BEHAVIOR */
			if (SDL_CollideBox(spirit, SPIRIT_X(playerx), SPIRIT_Y(playery), temp_mimage, monster[i].x, monster[i].y, 1, BBOX))
			{
				/* We want HP to be deducted in 2 second intervals */
				/* Otherwise the player dies too quickly (almost instantly) */
				
				if (!check_collision)
					goto skip_reduce_hp;

				gettimeofday(&tv, NULL);
				elapsed_time = tv.tv_sec - tv_sec1;
				if (elapsed_time >= 1)
				{
					if (no_sound == 0)
						PlaySound(&sound_file[PLAYER_GOT_HIT]);
					stats.hp -= monster[i].damage;
					*check_time = 1;
				}
				if (stats.hp <= 0)
					GameOver(inventory_font, screen);

				skip_reduce_hp:
				/* Jump player back a few steps */
				JumpBack(ENEMY);
				
				switch(monster[i].LastMove)
			 	{
						  case UP:
							 monster[i].LastMove = DOWN;
							 monster[i].direction = S;
							 break;
						  case DOWN:
							 monster[i].LastMove = UP;
							 monster[i].direction = N;
							 break;
						  case RIGHT:
							 monster[i].LastMove = LEFT;
							 monster[i].direction = W;
							 break;
						  case LEFT:
							 monster[i].LastMove = RIGHT;
							 monster[i].direction = E;
							 break;
				 }
						// monster[i].x = monster[i].prevX;
						 //monster[i].y = monster[i].prevY;

			 		
				 if (monster[i].LastMove == LEFT || monster[i].LastMove == RIGHT)
				 {
			 	 	if (monster[i].x < monster[i].prevX)
                                        	monster[i].x = monster[i].prevX + 2;
                                 	else
                                        	monster[i].x = monster[i].prevX - 2;
				 }
				 else
				 {		
                                 	if (monster[i].y < monster[i].prevY)
                                        	monster[i].y = monster[i].prevY + 2;
                                 	else
                                        	monster[i].y = monster[i].prevY - 2;
				 }
			 }
			 if (monster[i].multi_directional)
		 	 	temp_mimage = monster[i].animation[monster[i].direction][monster[i].image_index];
			 else
				temp_mimage = monster[i].image;
					  
			 if (!EnemyInBounds(temp_mimage, monster[i].x, monster[i].y, ActiveWorld, i))
			 {
			 	switch(monster[i].LastMove)
				{
					case UP:
						monster[i].LastMove = DOWN;
						monster[i].direction = S;
						break;
					case DOWN:
						monster[i].LastMove = UP;
						monster[i].direction = N;
						break;
					case RIGHT:
						monster[i].LastMove = LEFT;
						monster[i].direction = W;
						break;
					case LEFT:
						monster[i].LastMove = RIGHT;
						monster[i].direction = E;
						break;
				 }

				 if (monster[i].LastMove == LEFT || monster[i].LastMove == RIGHT)
                                 {
                                        if (monster[i].x < monster[i].prevX)
                                                monster[i].x = monster[i].prevX + 4;
                                        else
                                                monster[i].x = monster[i].prevX - 4;
                                 }
                                 else
                                 {
                                        if (monster[i].y < monster[i].prevY)
                                                monster[i].y = monster[i].prevY + 4;
                                        else
                                                monster[i].y = monster[i].prevY - 4;
                                 }

			  }

			  if (monster[i].y < y)
			  	DrawHero(&hero);

			  if (monster[i].image_count)
			  {

			  	if (monster[i].amc % monster[i].amv == 0)
					monster[i].image_index++;
				
				if (monster[i].multi_directional)
				{
					if(monster[i].attacked)
					{
						drawSprite(monster[i].animation_hit[monster[i].direction][monster[i].hit_count],
							   screen, 0, 0, monster[i].x, monster[i].y,
							   monster[i].size[monster[i].direction].w,
							   monster[i].size[monster[i].direction].h);
					}
					else
					drawSprite(monster[i].animation[monster[i].direction][monster[i].image_index],
						   screen, 0, 0, monster[i].x, monster[i].y,
						   monster[i].size[monster[i].direction].w,
						   monster[i].size[monster[i].direction].h);
				}
				else
					drawSprite(monster[i].images[monster[i].image_index], screen, 0, 0,
					monster[i].x, monster[i].y, monster[i].w, monster[i].h);

					if (monster[i].image_index == (monster[i].image_count - 1))
						monster[i].image_index = 0;
				}
				else
				drawSprite(monster[i].image, screen, 0, 0, monster[i].x, monster[i].y,
					monster[i].w, monster[i].h);
				flippit++;
			}
		}
		
		if (UsedSword)
		{
			for (i = 0; i < ActiveEnemies; i++)
			{	
				if (monster[i].multi_directional)
                                	temp_mimage = monster[i].animation[monster[i].direction][monster[i].image_index];
                         	else
                                	temp_mimage = monster[i].image;

                                if (HitEnemy(hero.attack[ManPos].image, tmpX, tmpY, temp_mimage, monster[i].x, monster[i].y))
                                {
                                	if (monster[i].multi_directional)
                                        	monster[i].attacked = 1;
                                        else
                                                monster[i].hit = 2;

 	                                if (monster[i].image_count && !monster[i].multi_directional)
                                        	monster[i].images[monster[i].image_index] = monster[i].hit_image[2];
                                        else
                                        if (!monster[i].image_count)
                                       		monster[i].image = monster[i].hit_image[2];

                                        monster[i].hp -= inventory.ActiveSword.damage;
                                        if (monster[i].hp <= 0)
                                        {
                                        	monster_x = monster[i].x;
                                                monster_y = monster[i].y;
                                                draw_explosion = 1;

                                                init_particles(monster[i].x+monster[i].w/2, monster[i].y+monster[i].h/2, 100);
                                                
						for (j = 0; j < 2; j++)
                                                	SDL_FreeSurface(monster[i].hit_image[j]);
                                                
						monster[i].status = 0;
                                                stats.exp = SetExp(stats.level, monster[i].max_hp, &stats);
                                                
						if (DropCoin(x, y))
                                                {
                                                	coin_data[ExistingCoins].status = 1;
                                                        coin_data[ExistingCoins].x = monster[i].x + (monster[i].w >> 1);
                                                        coin_data[ExistingCoins].y = monster[i].y + (monster[i].h >> 1);
                                                        ExistingCoins++;
                                                 }
                                       }

			         	if (monster[i].LastMove == LEFT || monster[i].LastMove == RIGHT)
                                 	{
                                        	if (monster[i].x < monster[i].prevX)
                                                	monster[i].x = monster[i].prevX - 10;
                                        	else
                                                	monster[i].x = monster[i].prevX + 10;
                                 	}
                                 	else
                                 	{
                                       		if (monster[i].y < monster[i].prevY)
                                                	monster[i].y = monster[i].prevY - 10;
                                        	else
                                                	monster[i].y = monster[i].prevY + 10;
                                 	}

                                }
					flippit++;
					UsedSword = 0;
			}
		}
		/* Separate loop for checking for spell collision */
		CheckMagic:
		if (UseMagic)
		{
			drawSprite(magic_image[inventory.ActiveSpell.id],
			screen, 0, 0, magX, magY, FLAME_W, FLAME_H);

			for (i = 0; i < ActiveEnemies; i++)
			{
				if (monster[i].status == 0)
					continue;
					if (monster[i].image_count)
					{
					       if (monster[i].multi_directional)
						       temp_mimage = monster[i].animation[monster[i].direction][monster[i].image_index];
					       else
						       temp_mimage = monster[i].images[monster[i].image_index];
					}

					if (SDL_CollideBoundingCircle(
					magic_image[inventory.ActiveSpell.id],
					magX, magY,
					temp_mimage,
					monster[i].x,
					monster[i].y, 2))
					{
						if (monster[i].multi_directional)
							monster[i].attacked = 1;
						 else
							monster[i].hit = 2;
						if (monster[i].image_count && !monster[i].multi_directional)
							monster[i].images[monster[i].image_index] = monster[i].hit_image[2];
						else
						if (!monster[i].image_count)
							monster[i].image = monster[i].hit_image[2];
						monster[i].hp -= inventory.ActiveSpell.damage;
						UseMagic = 0;
						if (monster[i].hp <= 0)
						{
							draw_explosion = 1;
							init_particles(
							monster[i].x+monster[i].w/2,
							monster[i].y+monster[i].h/2,
							300);

							monster[i].status = 0;
							stats.exp = SetExp(stats.level, monster[i].max_hp, &stats);
							if (DropCoin(x, y))
							{
								coin_data[ExistingCoins].status = 1;
								coin_data[ExistingCoins].x = monster[i].x + (monster[i].w >> 1);
								coin_data[ExistingCoins].y = monster[i].y + (monster[i].h >> 1);
								ExistingCoins++;
							}

							UseMagic = 0;
						}
					}


				}
			}
}

static void UpdateCoinPurse(int x, int y, SDL_Surface *coin)
{
	int i;
	SDL_Surface *tmp;
	
	if (hero.attacking)
		tmp = hero.attack[ManPos].image[step];
	else
		tmp = hero.walk[ManPos].image[step];

	for (i = 0; i < ExistingCoins; i++)
	{
		if (TouchedCoin(tmp, x, y, coin, coin_data[i].x, coin_data[i].y))
		{
			switch(CoinColor)
			{
				case 0:
					stats.gold += 1;
					break;
				case 1:
					stats.gold += 5;
					break;
				case 2:
					stats.gold += 20;
			}
			 coin_data[i].status = 0;
		}
	}
}
void DrawExplosion(int x, int y)
{

	int i;
	SDL_Surface *tmp;

	ClearBlack(screen);
	DrawWorld(ActiveWorld);
	DisplayStats(stats_font, stats, screen);
	DrawHero(&hero);
	DrawCoins();
	for (i = 0; i < ActiveEnemies; i++)
	{
		 if (monster[i].status)
		 	if (monster[i].multi_directional)
                        	tmp = monster[i].animation[monster[i].direction][monster[i].image_index];
                        else
                               	tmp = monster[i].images[monster[i].image_index];
		 drawSprite(tmp, screen, 0, 0, monster[i].x, monster[i].y,
			    monster[i].w, monster[i].h);
	}

       for (i = 0; i < EXPLOSION_TIME; i++)
       {
		DrawParticles(150);
		SDL_Flip(screen);
       }
       draw_explosion--;
}

int SendNet(int sock, struct game_packet *gp)
{
	char buf[1024];
	int b, i;

	memcpy(buf, gp, sizeof(struct game_packet));
	for (i = 0; i < sizeof(struct game_packet); i++)
		printf("%.2x", buf[i]);

	if ((b = write(sock, buf, sizeof(struct game_packet)) != sizeof(struct game_packet)))
	{
		printf("write to peer failed, wrote %d bytes\n", b);
		return -1;
	}
}


int RecvNet(int sock, struct game_packet *gp)
{
	char buf[1024];
	int c;

	if ((c = read (sock, buf, 1024)) == 0)
	{
		printf("Read zero bytes\n");
		return -1;
	}

	if (c == -1)
	{
		printf("read from peer failed\n");
		return -1;
	}

	memcpy((struct game_packet *)gp, buf, sizeof(struct game_packet));

	return 1;
} 


int HandleNetwork(int sock, struct game_packet *gp)
{
	int status;
	char buf[1024];

	status = socket_status(sock, 100);
	printf("x: %d y: %d direction: %d index: %d\n", gp->hero.x,gp->hero.y,gp->direction,gp->image_index);

	memcpy(buf, gp, sizeof(struct game_packet));
	switch (status)
	{
		case SOCKREAD:
			memset(gp, 0, sizeof(struct game_packet));
			if (RecvNet(sock, gp) == -1)
				printf("Error retrieving packet from peer\n");
			return SOCKREAD;
			break;
		case SOCKWRITE:
			if (SendNet(sock, gp) == -1)
				printf("Error sending packet to peer\n");
			return SOCKWRITE;
			break;
		case 0:
			return 0;
	}
	
}
		
struct timeval music_tv;
uint32_t music_ticks;

static void MainLoop(void)
{
	
	GameActive = 1;
	SDL_Event event, subevent, dsubevent;
	
	char InvPressed = 0, SpacePressed = 0;
	int j = 0;
	int8_t HitInventoryKey = 0;
	int8_t Yes = 0, No = 0, selection = 0;
	struct merchant_info merchant;
	
	SDL_Surface *Man;
	SDL_Surface *frame[512]; 
	SDL_Color fg;
	
	char draw_frame = 0;
	SDLKey key, subkey, dsubkey;
	int lastX = 0, lastY = 0;
	
	/* oldY/X are to restore cords outside of house */
	int oldY, oldX;
	int i;

	int InInventory = 0;
	/* man/sword width/height */
	int mw, mh, sw, sh;
	int MagDir;
	
	/* We use a timer to prevent MP from being drained immediately */
	struct timeval magic_tv1, magic_tv2;
	
	/* We use a timer to prevent sword from being held down continuesly */
	struct timeval sword_tv1, sword_tv2;
	struct timeval mp_tv1, mp_tv2;
	uint32_t mtv = 0, stv = 0, mp_tv = 0;
	//char FirstTime = 1;
	
	/* SDL_Flip ? */
	uint8_t check_time = 1;
	int elapsed_time = 0;
	int ActionButton = 0;
	
	int TmpActiveWorld = ActiveWorld;
	char GetLoopTime = 0;

	/* Some more stuff for printing text */
	SDL_Color font_fg = {0xff, 0xff, 0xff, 0};
	SDL_Color font_bg = {0x00, 0x00, 0x00, 0};


	uint32_t mp_counter = 0;
	
	/* temporary monster image */
	SDL_Surface *temp_mimage;

	struct dialog_info dialogs[32]; // = (struct dialog_info *)malloc (32 * sizeof(struct dialog_info));

	yPOS = 0;
	yNEG = 0;
	xPOS = 0;
	xNEG = 0;

	SDL_EnableKeyRepeat(1, 1);
	
	LoadImages();
	/* Draw initial environment */
	
	CoinType[0] = coin_blue;
        CoinType[1] = coin_red;
        CoinType[2] = coin_purple;
	
	/* LOAD STARTING STATS */
	if (LoadGame == 0)
	{
		init_start_stats();
		playerx = x = global_x;
		playery = y = global_y;
		GameActive = 1;
	}
	/* LOAD GAME FROM SAVE FILE */
	else
	{
		/* load_game() was called in main() */
		/* Which filled struct save_data sd */
		playerx = x = sd.x;
		playerx = y = sd.y;
	
		inventory.ActiveSword.id = sd.ActiveSword.id;
		inventory.ActiveSpell.id = sd.ActiveSpell.id;
		inventory.ActiveArmor.id = sd.ActiveArmor.id;
		
		inventory.ActiveSword.damage = sd.ActiveSword.damage;
	 	inventory.ActiveSpell.damage = sd.ActiveSpell.damage;
		inventory.ActiveArmor.damage_intake = sd.ActiveArmor.damage_intake;

		for (i = 0; i < sd.item_count; i++)
		{
			inventory.items[i].item_id = sd.item[i].item_id;
			inventory.items[i].quanity = sd.item[i].quanity;
		}

		stats.NextLevel = sd.next_level;
		
		stats.level = sd.stats.level;
		stats.gold = sd.stats.gold;
		stats.hp = sd.stats.hp;
		stats.mp = sd.stats.mp;
		stats.exp = sd.stats.exp;
		ActiveWorld = sd.ActiveWorld;

		
	}

	/* Draw the initial world */
 	DrawWorld(ActiveWorld);
	NewFrame = 0;
	current_frame_images = ALREADY_LOADED;

	if (hero.attacking)
        	drawSprite(hero.attack[ManPos].image[step], screen, 0, 0, x, y, hero.attack[ManPos].sz[step].w, hero.attack[ManPos].sz[step].h);
        else
        	drawSprite(hero.walk[ManPos].image[step], screen, 0, 0, x, y, hero.walk[ManPos].sz[step].w, hero.walk[ManPos].sz[step].h);
	SDL_Flip(screen);
	
	init_NPC(ActiveWorld, dialogs);
	init_monsters(ActiveWorld);
	uint32_t tick1, tick2;
	int CheckFrame = 0;
	int frames = 0;

	int cursor_position = 0;
	int8_t item_action = 0;
	long local_fps = 0;

	cursor_image = LoadAlphaImage("bmp/intro/select.png");
	cursor_image_selected = LoadAlphaImage("bmp/intro/selected.png");
	
	for (i = 0; i < 32; i++)
		dialogs[i].index = 0;
	
        while(GameActive)
        {
	 	SDL_Delay(TimeLeft());
		
#ifdef DEBUG
		GET_FPS();
		if (CHECK_FPS)
		{
			CHECK_FPS = 0;
			frames = 0;
			fps_val = 0;
		}
#endif
		if (hero.attacking)
		{	
			if ((hero.attack_amc++ % hero.attack_amv) == 0)
				step++;
			if (step >= (hero.attack_count))
			{
				step ^= step;
				hero.attacking ^= hero.attacking;
			}
			/*
			if (ManPos == 0 && step >= 3)
				tmpX -= 1;
			*/
			goto move_along;
		}
		if (Moving)
		{
	 		if ((hero.amc++ % hero.amv) == 0)
	 		{	
				if (yNEG && !xPOS && !xNEG)
				step += 2;
				else
				if (yPOS && !xNEG && !xPOS)
					step += 2;
				else
					step++;
			}
			if (step >= (hero.walk_count))
                               step ^= step;
		}
		else
			step = 1;
			
		 move_along:

		 global_x = x;
		 global_y = y;
		
	 	 if (NewFrame)
		 	ExistingCoins = 0;

		 AtleastOneCoinActive = 0;

		 /* Our explosion is drawn for killed enemies here */
		 if (draw_explosion)
		 	DrawExplosion(x, y);	

		 /* MAGIC SPELL TIMERS */
		 /* Determines how much time between spell casts */
		 if (mtv == 0)
		 {
			gettimeofday(&magic_tv1, NULL);
			mtv = magic_tv1.tv_sec;
				
		 }

		 /* Handle Theme Sound Track */
		 if (no_sound == 0)
		 {
		 	if (music_ticks == 0)
		 	{
				PlaySound(&sound_file[BG_MUSIC_1]);
		 		gettimeofday(&music_tv, NULL);
		 		music_ticks = music_tv.tv_sec;
		 	}
		 	else
		 	{
				gettimeofday(&music_tv, NULL);
				if ((music_tv.tv_sec - music_ticks) >= sound_wave[CurrentSong].time)
					/* Start song over */
					music_ticks = 0;
		 	 }		
		 }	

		 /* Increase MP as needed */
		 mp_counter++;
		 IncreaseMP(&mp_counter);	
		 
		 /* Which part of the map are we? This makes sure we are at the right location */
		 /* So that DrawWorld() acts accordingly */
		 TmpActiveWorld = ActiveWorld;
		 if ((ActiveWorld = WhichFrame(ActiveWorld, &x, &y)) != TmpActiveWorld)
		 {
			/* We've changed active frames */

			/* Initialize enemies */
			init_monsters(ActiveWorld);

			/* Initialize NPC's */
			init_NPC(ActiveWorld, dialogs);
			UseMagic = 0;
			ClearCords(&yPOS, &yNEG, &xPOS, &xNEG);
		 	playery = y;
			playerx = x;
		 }
		 if (check_time == 1)
		 {
			 gettimeofday(&tv, NULL);
			 tv_sec1 = tv.tv_sec;
			 check_time = 0;
		 }
 
		 /* Set speed angle and location of projectile spell */
		 if (UseMagic)
		 	SetSpellVelocity(&UseMagic, &MagDir);
		 	
		 /* Set speed and location of enemies */

		 SetEnemyCoords(monster, playerx, playery);

		 ClearCords(&xPOS, &xNEG, &yPOS, &yNEG);
		 diagnol = 0;
		 Moving = 0;

                 if(SDL_PollEvent(&event))
		 {
			if (testKey(SDLK_UP) && testKey(SDLK_RIGHT))
			{
				Moving = 1;
				y -= MOVE_INCREMENT;
				x += MOVE_INCREMENT;
				mw = 31;
				mh = 30;
				ManPos = 1;
				yNEG++;
				xPOS++;
				global_diagnol = diagnol = 1;
				goto skip_cases;
			}
			
			if (testKey(SDLK_UP) && testKey(SDLK_LEFT))
			{
				Moving = 1;
				y -= MOVE_INCREMENT;
				x -= MOVE_INCREMENT;
				mw = 29;
				mh = 23;
				ManPos = 7; /* man8.bmp */
				yNEG++;
				xNEG++;
				global_diagnol = diagnol = 1;
				goto skip_cases;
			}


			if (testKey(SDLK_DOWN) && testKey(SDLK_RIGHT))
                        {
				Moving = 1;
                                y += MOVE_INCREMENT;
                                x += MOVE_INCREMENT;
                                mw = 29;
                                mh = 23;
                                ManPos = 3;
                                yPOS++;
                                xPOS++;
				global_diagnol = diagnol = 1;
                                goto skip_cases;
                        }
			
			if (testKey(SDLK_DOWN) && testKey(SDLK_LEFT))
                        {
				Moving = 1;
                                y += MOVE_INCREMENT;
                                x -= MOVE_INCREMENT;
                                mw = 25;
                                mh = 31;
                                ManPos = 5; /* man8.bmp */
                                yPOS++;
                                xNEG--;
				global_diagnol = diagnol = 1;
                                goto skip_cases;
                        }

                 	switch(event.type)
			{
				case SDL_KEYUP:
					if (SpacePressed)
						SpacePressed = 0;
					else
					if (InvPressed)
						InInventory = InvPressed = 0;
					break;
				case SDL_QUIT: 
                                	GameActive--; 
					break;
				case SDL_VIDEORESIZE:
					screen = SDL_SetVideoMode(event.resize.w, event.resize.h, 16, SDL_RESIZABLE | SDL_DOUBLEBUF |  SDL_HWSURFACE);
					break;
				case SDL_KEYDOWN:
					key = event.key.keysym.sym;
					Moving = 1;
					switch(key)
					{
						
						case SDLK_F1:
						/* SAVE GAME */
							collect_save_data(&sd, x, y);	
							save_game(game_id, sd);
							break;
						/* --- INVENTORY --- */
						case SDLK_i:
							if (InvPressed == 0)
							{
								InInventory = InvPressed = 1;
								SDL_Delay(250);
							}
								
							break;
						case SDLK_a:
								/* --- ACTION BUTTON --- */
							ActionButton = 1;
							if (InHouse)  /* Generic House action with merchant */
							{
								if (x >= 234 && x <= 342 && (y >= 138 && y <= 180))
									talk2merchant(ActiveHouse, &stats);
								break;
							}
								talk2NPC(ActiveWorld, ActiveNPC, dialogs);	 
								break;
						case SDLK_s:
							if (stats.mp == 0)
								break;
							/* Only let a spell be cast every 2 seconds */
							gettimeofday(&magic_tv2, NULL);
							if ((magic_tv2.tv_sec - mtv) >= 2)
							{
								UseMagic = 1;
								/* Subtract MP from player */
								stats.mp -= inventory.ActiveSpell.rmp;
								mtv = 0;
							}
							break;
						case SDLK_ESCAPE:
							GameActive--;
							break;
						case SDLK_UP:
							if (diagnol)
								break;
							y -= MOVE_INCREMENT;
							ManPos = 0; 
							yNEG++;
							break;
						case SDLK_DOWN:
							if (diagnol)
                                                        	break;
                                                             
							y += MOVE_INCREMENT;
							ManPos = 4;	
							yPOS++;
							break;
						case SDLK_LEFT:	
							if (diagnol)
                                                                break;
							x -= MOVE_INCREMENT;
							ManPos = 6;
							xNEG++;
							break;
						case SDLK_RIGHT:
							if (diagnol)
                                                        	break;
							x += MOVE_INCREMENT;
							ManPos = 2;
							xPOS++;
							break;
						case SDLK_SPACE:	
							if (SpacePressed == 0)
							{
								SwordPos = ManPos;
								UseSword = 1;
								SpacePressed = 1;
							}
							else
								break;
							break;

						}
					skip_cases:
	
					/* --- OPEN INVENTORY SCREEN --- */
					/* The inventory screen is controlled by an event loop */
					if (InInventory)
					{
						
						list_inventory:
						ClearBlack(screen);
						ListInventory(small_font, inventory_font, &inventory, "lavren", screen, cursor_position, item_action, &stats);
						SDL_Flip(screen);

						/* Handle inventory operations */
						WaitInventoryKey:
						
						if (INVENTORY_UPDATE)
						{
							item_action = 0;
							INVENTORY_UPDATE = 0;
							goto list_inventory;
						}

						HitInventoryKey = 0;
						SDL_WaitEvent(&subevent);
						
						switch(subevent.type)
						{
							case SDL_KEYDOWN:
                                                	subkey = subevent.key.keysym.sym;

							switch(subkey)
							{
							case SDLK_i:	
								HitInventoryKey = 1;
								InInventory = 0;
								cursor_position = 0;
								item_action = 0;
								break;
							case SDLK_UP:
								cursor_position = CURSOR_UP;
								item_action = 0;
								goto list_inventory;
							case SDLK_RIGHT:
								cursor_position = CURSOR_RIGHT;
								item_action = 0;
								goto list_inventory;
							case SDLK_DOWN:
								cursor_position = CURSOR_DOWN;
								item_action = 0;
								goto list_inventory;
							case SDLK_LEFT:
								cursor_position = CURSOR_LEFT;
								item_action = 0;
								goto list_inventory;
							case SDLK_RETURN:
							case SDLK_SPACE:
								/* notify the inventory screen that */
								/* we are interested in an item */
								item_action = REQUEST_ITEM;
								goto list_inventory;
							
							/* These apply if return/space were hit on item */
							case SDLK_u:
								if (item_action != REQUEST_ITEM)
									break;
								item_action = USE_ITEM;
								goto list_inventory;
							case SDLK_d:
								if (item_action != REQUEST_ITEM)
									break;
								item_action = DROP_ITEM;
								goto list_inventory;
							case SDLK_b:
								if (item_action != REQUEST_ITEM)
                                                                        break;
								if (item_action == GO_BACK)
								{
									item_action = 0;
									cursor_position = 0;
									goto list_inventory;
								}
								item_action = GO_BACK;
								cursor_position = 0;
								goto list_inventory;

							}

							break;
						}
	
						if (HitInventoryKey == 0)
							goto WaitInventoryKey;
						continue;
					}
					/* - END INVENTORY OPERATIONS - */

					ClearBlack(screen);
                                        if(!InHouse)
                                               DrawWorld(ActiveWorld);
                                        else
                                               DrawHouse();
					
					if (!InHouse)
					{
					 	if (HitHouse(x, y, ActiveWorld))
					 	{
							/* Save coordinates */
							/* To return too once we lave house */
							oldX = x;
							oldY = y;
							InHouse = 1;
							NewFrame = 1;
					 		y = 500;
							x = 400;
							/* We must load the current frame images for the house */
							current_frame_images = 0;
							DrawHouse();
						}
					}
					else /* If In House */
					{
						/* If guy is below threshold */
						/* go back out into world */
						if (y >= 500)
						{
							SDL_FreeSurface(floor1);
							SDL_FreeSurface(merchant1);
							SDL_FreeSurface(table1);
							/* Restore coordinates */
							x = oldX;
							y = oldY;
							InHouse = 0;
						}
						
					}
					 
					if (ExistingCoins)
						UpdateCoinPurse(x, y, CoinType[CoinColor]);

						
					/* IF IN BOUNDS MOVE TO NEXT COORIDINATES */			
					if (InBounds(x, y, InHouse ? ActiveHouse : ActiveWorld))
                                       	{
				 		playerx = x;
						playery = y;
				 	} 
					/* ELSE TAKE A STEP BACK */
				 	else
						JumpBack(OBJECT);

					if (UseSword)
					{
						tmpY = playery;
						tmpX = playerx;
						
						switch(SwordPos)
                                                {
                                                case 0:
                                                        //tmpX -= 1;
                                                        break;
                                                case 1:
                                                        break;
                                                case 2:
                                                        break;
                                                case 3:
                                                        break;
                                                case 4:
                                                        break;
                                                case 5:
                                                        break;
                                                case 6:
                                                        break;
                                                case 7:
                                                        break;
                                                }

						if (no_sound == 0)
							PlaySound(&sound_file[PLAYER_STRIKE_SWORD]);
						hero.attacking = 1;
						step = 0;
						ClearBlack(screen);
						
						if (!InHouse)
							DrawWorld(ActiveWorld);
						else
						if (InHouse)
							DrawHouse();

						if (!InHouse)
							draw_NPC(ActiveNPC, playerx, playery, ActiveWorld);
						
						if (!InHouse)
							enemy_loop(&check_time);		

						if (UseMagic)
							drawSprite(magic_image[inventory.ActiveSpell.id],
                                                                   screen, 0, 0, magX, magY, FLAME_W, FLAME_H);
						
						DrawCoins();
						DisplayStats(stats_font, stats, screen);
						SDL_Flip(screen);
						usleep(SWORD_TIMING);
						UseSword = 0;
						/* If we used sword, we must refresh screen */
						UsedSword = 1;
						continue;
					 }
					 if (!InHouse)
					 	enemy_loop(&check_time);

					 DrawCoins();
					 if (!InHouse)
					 	draw_NPC(ActiveNPC, playerx, playery, ActiveWorld);
					 DisplayStats(stats_font, stats, screen);
					 SDL_Flip(screen);
					 continue;
			}
			

		}

	       /* --- NO EVENT --- */

		DrawCoins();

		if (!InHouse)
		{
			ClearBlack(screen);
			//enemy_loop(&check_time);
                	DrawWorld(ActiveWorld);
			draw_NPC(ActiveNPC, playerx, playery, ActiveWorld);
			enemy_loop(&check_time);
		}
		if (UsedSword)
		{
			step++;
			flippit++;
			UsedSword = 0;
		}
		if (UseMagic)
		{
			if (InHouse)
			{
				ClearBlack(screen);
				DrawHouse();
			}
			flippit++;
			drawSprite(magic_image[inventory.ActiveSpell.id],
                                   screen, 0, 0, magX, magY, FLAME_W, FLAME_H);
		}
		if (flippit)
		{
			DisplayStats(stats_font, stats, screen);
			SDL_Flip(screen);
			flippit = 0;
		}
	}

	cleanup();
}

void cleanup(void)
{
	ClearBlack(screen);
	GameOver(inventory_font, screen);	
}

void intro(void)
{
	int i = 0;
	TTF_Font *intro_font;

	SDL_Surface *image[32];
	char buf[255] = {0};
	struct text_surface ts[50];
	SDL_Color font_fg = {0x00, 0x00, 0x00, 0x00};

	if ((intro_font = TTF_OpenFont(INTRO_FONT, 16)) == NULL)
	{
		printf("Unable to load font: %s %s\n", STATS_FONT, TTF_GetError());
		exit(0);
	}

	
	/* Load intro images into memory */
	for (i = 0; i < 14; i++)
	{
		sprintf(buf, "bmp/intro/comic-page%d.bmp", i+1);
		image[i] = LoadImage(buf);
		memset(buf, 0, sizeof(buf));
	}

	for (i = 0; i < 7; i++)
	{
		ClearBlack(screen);
		drawSprite(image[i], screen, 0, 0, 0, 0, 640, 480);
		SDL_Flip(screen);
		SDL_Delay(500);
	}

	ts[0].s = TTF_RenderText_Blended(intro_font, "Hello, Lavren... My name is Zen", font_fg);
	ts[1].s = TTF_RenderText_Blended(intro_font, "I have visited you before, in your dreams", font_fg);
	ts[2].s = TTF_RenderText_Blended(intro_font, "And you have seen me before...", font_fg);
	ts[3].s = TTF_RenderText_Blended(intro_font, "for I am the light...", font_fg);
	ts[4].s = TTF_RenderText_Blended(intro_font, "but I must bestow a terrible burden upon you", font_fg);
	ts[5].s = TTF_RenderText_Blended(intro_font, "Until now, you have believed you were human, but the truth is", font_fg);
	ts[6].s = TTF_RenderText_Blended(intro_font, "You come from another world, and only bare physical semblance to a human", font_fg);
	ts[7].s = TTF_RenderText_Blended(intro_font, "In this human realm, your magic was stripped from you upon entrance", font_fg);
	ts[8].s = TTF_RenderText_Blended(intro_font, "I have come to impute you with those powers once again...", font_fg);
	ts[9].s  = TTF_RenderText_Blended(intro_font,"And give you a quest that no human can endure...", font_fg);
	ts[10].s = TTF_RenderText_Blended(intro_font, "A wicked darkness is present, and the land will soon be consumed", font_fg);
	ts[11].s = TTF_RenderText_Blended(intro_font, "Until a crepescular frenzy dominates the entire land -- ALAS! -- only a seer kind", font_fg);
	ts[12].s = TTF_RenderText_Blended(intro_font, "such as you... can defeat this power, and bring peace.", font_fg);
	ts[13].s = TTF_RenderText_Blended(intro_font, "Go to the gate with the dragon on it, it will take you deep into a mountain pass", font_fg);
	ts[14].s = TTF_RenderText_Blended(intro_font, "Find an old man named Sydel, he shares your origins. From there, it is up to you.", font_fg);
	ts[15].s = TTF_RenderText_Blended(intro_font, "I must go Lavren... be strong", font_fg);

	for (i = 0; i < 15; i++)
	{
		ClearBlack(screen);
		drawSprite(image[7], screen, 0, 0, 0, 0, 640, 480);
		drawSprite(ts[i].s, screen, 0, 0, 50, 380, 640, 40);
		SDL_Flip(screen);
		SDL_Delay(4500);
	}
	
	for (i = 8; i < 14; i++)
	{
		ClearBlack(screen);
		drawSprite(image[i], screen, 0, 0, 0, 0, 640, 480);
		SDL_Flip(screen);
		SDL_Delay(500);
	}
}

void JumpBack(int object)
{
	int value;

	//if (object == OBJECT)
		value = MOVE_INCREMENT;
	//else
	/* Assuming its an enemy */
	//value = MOVE_INCREMENT << JMP_SHIFT;
	
	if (diagnol)
        {
        	if (yNEG && xPOS)
                {
                	playery = y += value;
                        playerx = x -= value;
                }
                else
                if (yNEG && xNEG)
                {
                	playery = y += value;
                        playerx = x += value;
                }
                else
                if (yPOS && xPOS)
                {
                        playery = y -= value;
                        playerx = x -= value;
                }
                else
                if (yPOS && xNEG)
                {
                	playery = y -= value;
                        playerx = x += value;
                }
        }
        else
        {	
        	if (yPOS)
                	playery = y -= value;
                else
                if (yNEG)
                        playery = y += value;
                else
                if (xNEG)
                        playerx = x += value;
		else
		if (xPOS)
			playerx = x -= value;
		else
		if (!xPOS && object == ENEMY)
		{
			playerx = x -= value;
		}
		
	}
}


