#include "rpg.h"
#include "SDL_rotozoom.h"

extern SDL_Surface *blank, *blank_grass1, *blank_grass2, *blank_grass3, *dirt_path, *screen, *trees, *trees_right_border,
	*trees_side_border, *trees2, *trees_horizontal_border, *house1, *blue_pond,
	*floor1, *table1, *dragon_door, *statue_lake, *trees_top_border_short,
	*merchant1;
extern SDL_Surface *man[9];
extern SDL_Surface *sword[9];
extern SDL_Surface *inventory1;
extern SDL_Surface *magic_image[0xf];
extern SDL_Surface *fog2, *fog1, *ParticleDot, *ParticleDotBlue,
	*ParticleDotRed;
extern SDL_Surface *cave_bottom, *cave_top, *cave_blue, *cave_red,
	*cave_purple;
extern SDL_Surface *coin_blue, *coin_red, *coin_purple;
extern SDL_Surface *lavren;

extern SDL_Surface *magenta_rec, *magenta_rec2, *magenta_rec3, *magenta_top;
extern SDL_Surface *spirit[4];

extern int ManPos, tmpX, tmpY, x, y, step;
extern int xPOS, xNEG, yPOS, yNEG;
extern int server_mode, client_mode;
extern int8_t global_sock;
extern int ActiveWorld, InHouse;
int BuildPacket(struct game_packet *gp, struct hero *hero)
{
        gp->hero.x = x;  
        gp->hero.y = y; 
        gp->direction = ManPos;
        gp->image_index = step;
        gp->ActiveWorld = ActiveWorld;
        gp->InHouse = InHouse;

	if (hero->attacking)
		gp->attacking = 1;
	else
		gp->attacking = 0;
}

void DrawHero(struct hero *hero)
{
	struct game_packet gp;
	int val;
	/* We handle drawing the multi-player hero here as well, seems to be a logical place to do it */
	
	if (server_mode || client_mode)
	{
		BuildPacket (&gp, hero);
		if (client_mode)
			val = HandleNetwork(global_sock, &gp);
			
		if (val == SOCKREAD)
		{
		 	if (gp.attacking)
				drawSprite(hero->attack[gp.direction].image[gp.image_index], screen, 0, 0, gp.hero.x, gp.hero.y, 
				hero->attack[gp.direction].sz[gp.image_index].w, hero->attack[gp.direction].sz[gp.image_index].h);
			else
				drawSprite(hero->walk[gp.direction].image[gp.image_index], screen, 0, 0, gp.hero.x, gp.hero.y,
                                hero->walk[gp.direction].sz[gp.image_index].w, hero->attack[gp.direction].sz[gp.image_index].h);
		}
	}			

	if (hero->attacking)
                drawSprite(hero->attack[ManPos].image[step], screen, 0, 0, tmpX, tmpY, hero->attack[ManPos].sz[step].w, hero->attack[ManPos].sz[step].h);
        else
                drawSprite (hero->walk[ManPos].image[step], screen, 0, 0, x, y, hero->walk[ManPos].sz[step].w, hero->walk[ManPos].sz[step].h);
}

int SPIRIT_X(int sx)
{
	/* West */
	if (xNEG)
		return sx + 20;

	/* East */
	if (xPOS)
		return sx - 10;
	
	return sx + 10;
}

int SPIRIT_Y(int sy)
{
	return sy + 25;
}

int
SDL_CollideBox (SDL_Surface ** sa, int ax, int ay,
		SDL_Surface * sb, int bx, int by, int array_index, int type)
{
	/* Which collision detection method should we use? */ 
	int i;

	if (type == BBOX)
		for (i = 0; i < array_index; i++)
		{
			if (SDL_CollideBoundingBox(sa[i], ax, ay, sb, bx, by))
				return 1;
		}
	else
		for (i = 0; i < array_index; i++)
                {
                        if (SDL_CollidePixel(sa[i], ax, ay, sb, bx, by))
                                return 1;
                }
	return 0;
}

void
ClearCords (int *yPOS, int *yNEG, int *xPOS, int *xNEG)
{
	*yPOS ^= *yPOS;
	*yNEG ^= *yNEG;
	*xPOS ^= *xPOS;
	*xNEG ^= *xNEG;
}

void do_panic(void)
{
	SDL_Quit();
	exit(0);
}

void
GameOver (TTF_Font * font, SDL_Surface * screen)
{
	SDL_Surface *text;
	SDL_Color font_red = { 0xff, 0x00, 0x00, 0x00 };
	SDL_Color font_bg = { 0x00, 0x00, 0x00, 0x00 };

	text = TTF_RenderText_Shaded (font, "Game Over", font_red, font_bg);
	drawSprite (text, screen, 0, 0, 250, 200, 200, 10);
	SDL_Flip (screen);
	SDL_Delay(500);
	SDL_Quit();
	exit(0);
}

/* This determines if money will appear from enemy */

bool
DropCoin (int x, int y)
{
	int v;

	srand (x * y);
	v = rand () & 0xff;
	if (((v % 3) == 0) || ((v % 5) == 0) || ((v % 15) == 0))
		return true;
	return false;

}

/*
struct hero
{
        int x, y;
        int attack_amc, attack_amv;
        int spell_amc, spell_amv;
        int amc, amv;

        SDL_Surface *walk[8][4];
        SDL_Surface *walk_no_sword[8][4];
        SDL_Surface *attack[8][4];

        int walk_count;
        int attack_count;

        int walk_index;
        int attack_index;

        int w;
        int h;

};
*/
int LoadHero(struct hero *hero)
{
	

	/* These values are passed to the zoomSurface */
	/* function for scaling the size of the hero bitmap :) */
	double w = 0.2-((0.06) - 0.005), h = 0.2-((0.06) - 0.005);

	hero->attacking = 0;

	hero->walk_count = 6;
	hero->attack_count = 4;

	hero->amc = 0;
	hero->amv = 3;

	hero->attack_amc = 0;
	hero->attack_amv = 2;

	hero->walk[NORTH].image[0] = LoadImage("bmp/hero/hero_walk_n1.bmp");
	hero->walk[NORTH].image[1] = LoadImage("bmp/hero/hero_walk_n2.bmp");
	hero->walk[NORTH].image[2] = LoadImage("bmp/hero/hero_walk_n3.bmp");
		
	get_bmp_size ("bmp/hero/hero_walk_n1.bmp", &hero->walk[NORTH].sz[0].w, &hero->walk[NORTH].sz[0].h);
	get_bmp_size ("bmp/hero/hero_walk_n2.bmp", &hero->walk[NORTH].sz[1].w, &hero->walk[NORTH].sz[1].h);
	get_bmp_size ("bmp/hero/hero_walk_n3.bmp", &hero->walk[NORTH].sz[2].w, &hero->walk[NORTH].sz[2].h);

	hero->walk[NE].image[0] = LoadImage("bmp/hero/hero_walk_ne1.bmp");
        hero->walk[NE].image[1] = LoadImage("bmp/hero/hero_walk_ne2.bmp");
        hero->walk[NE].image[2] = LoadImage("bmp/hero/hero_walk_ne3.bmp");

	get_bmp_size ("bmp/hero/hero_walk_ne1.bmp", &hero->walk[NE].sz[0].w, &hero->walk[NE].sz[0].h);
        get_bmp_size ("bmp/hero/hero_walk_ne2.bmp", &hero->walk[NE].sz[1].w, &hero->walk[NE].sz[1].h);
        get_bmp_size ("bmp/hero/hero_walk_ne3.bmp", &hero->walk[NE].sz[2].w, &hero->walk[NE].sz[2].h);

	hero->walk[NW].image[0] = LoadImage("bmp/hero/hero_walk_nw1.bmp");
	hero->walk[NW].image[1] = LoadImage("bmp/hero/hero_walk_nw2.bmp");
        hero->walk[NW].image[2] = LoadImage("bmp/hero/hero_walk_nw3.bmp");

	get_bmp_size ("bmp/hero/hero_walk_nw1.bmp", &hero->walk[NW].sz[0].w, &hero->walk[NW].sz[0].h);
        get_bmp_size ("bmp/hero/hero_walk_nw2.bmp", &hero->walk[NW].sz[1].w, &hero->walk[NW].sz[1].h);
        get_bmp_size ("bmp/hero/hero_walk_nw3.bmp", &hero->walk[NW].sz[2].w, &hero->walk[NW].sz[2].h);

	hero->walk[SOUTH].image[0] = LoadImage("bmp/hero/hero_walk_s1.bmp");
        hero->walk[SOUTH].image[1] = LoadImage("bmp/hero/hero_walk_s2.bmp");
        hero->walk[SOUTH].image[2] = LoadImage("bmp/hero/hero_walk_s3.bmp");

	get_bmp_size ("bmp/hero/hero_walk_s1.bmp", &hero->walk[SOUTH].sz[0].w, &hero->walk[SOUTH].sz[0].h);
        get_bmp_size ("bmp/hero/hero_walk_s2.bmp", &hero->walk[SOUTH].sz[1].w, &hero->walk[SOUTH].sz[1].h);
        get_bmp_size ("bmp/hero/hero_walk_s3.bmp", &hero->walk[SOUTH].sz[2].w, &hero->walk[SOUTH].sz[2].h);

        hero->walk[SE].image[0] = LoadImage("bmp/hero/hero_walk_se1.bmp");
        hero->walk[SE].image[1] = LoadImage("bmp/hero/hero_walk_se2.bmp");
        hero->walk[SE].image[2] = LoadImage("bmp/hero/hero_walk_se3.bmp");
	hero->walk[SE].image[3] = LoadImage("bmp/hero/hero_walk_se4.bmp");
        hero->walk[SE].image[4] = LoadImage("bmp/hero/hero_walk_se5.bmp");
        hero->walk[SE].image[5] = LoadImage("bmp/hero/hero_walk_se6.bmp");
	hero->walk[SE].image[6] = LoadImage("bmp/hero/hero_walk_se7.bmp");
        hero->walk[SE].image[7] = LoadImage("bmp/hero/hero_walk_se8.bmp");

	hero->walk[SE].image[0] = zoomSurface( hero->walk[SE].image[0], w, h, 1);
	hero->walk[SE].image[1] = zoomSurface( hero->walk[SE].image[1], w, h, 1);
	hero->walk[SE].image[2] = zoomSurface( hero->walk[SE].image[2], w, h, 1);
	hero->walk[SE].image[3] = zoomSurface( hero->walk[SE].image[3], w, h, 1);
        hero->walk[SE].image[4] = zoomSurface( hero->walk[SE].image[4], w, h, 1);
        hero->walk[SE].image[5] = zoomSurface( hero->walk[SE].image[5], w, h, 1);
 	hero->walk[SE].image[6] = zoomSurface( hero->walk[SE].image[6], w, h, 1);
        hero->walk[SE].image[7] = zoomSurface( hero->walk[SE].image[7], w, h, 1);

	get_bmp_size ("bmp/hero/hero_walk_se1.bmp", &hero->walk[SE].sz[0].w, &hero->walk[SE].sz[0].h);
        get_bmp_size ("bmp/hero/hero_walk_se2.bmp", &hero->walk[SE].sz[1].w, &hero->walk[SE].sz[1].h);
        get_bmp_size ("bmp/hero/hero_walk_se3.bmp", &hero->walk[SE].sz[2].w, &hero->walk[SE].sz[2].h);
 	get_bmp_size ("bmp/hero/hero_walk_se4.bmp", &hero->walk[SE].sz[3].w, &hero->walk[SE].sz[3].h);
        get_bmp_size ("bmp/hero/hero_walk_se5.bmp", &hero->walk[SE].sz[4].w, &hero->walk[SE].sz[4].h);
        get_bmp_size ("bmp/hero/hero_walk_se6.bmp", &hero->walk[SE].sz[5].w, &hero->walk[SE].sz[5].h);
 	get_bmp_size ("bmp/hero/hero_walk_se7.bmp", &hero->walk[SE].sz[6].w, &hero->walk[SE].sz[6].h);
        get_bmp_size ("bmp/hero/hero_walk_se8.bmp", &hero->walk[SE].sz[7].w, &hero->walk[SE].sz[7].h);

	hero->walk[SW].image[0] = LoadImage("bmp/hero/hero_walk_sw1.bmp");
        hero->walk[SW].image[1] = LoadImage("bmp/hero/hero_walk_sw2.bmp");
        hero->walk[SW].image[2] = LoadImage("bmp/hero/hero_walk_sw3.bmp");

	get_bmp_size ("bmp/hero/hero_walk_sw1.bmp", &hero->walk[SW].sz[0].w, &hero->walk[SW].sz[0].h);
        get_bmp_size ("bmp/hero/hero_walk_sw2.bmp", &hero->walk[SW].sz[1].w, &hero->walk[SW].sz[1].h);
        get_bmp_size ("bmp/hero/hero_walk_sw3.bmp", &hero->walk[SW].sz[2].w, &hero->walk[SW].sz[2].h);

	hero->walk[WEST].image[0] = LoadImage("bmp/hero/hero_walk_w1.bmp");
        hero->walk[WEST].image[1] = LoadImage("bmp/hero/hero_walk_w2.bmp");
        hero->walk[WEST].image[2] = LoadImage("bmp/hero/hero_walk_w3.bmp");

	get_bmp_size ("bmp/hero/hero_walk_w1.bmp", &hero->walk[WEST].sz[0].w, &hero->walk[WEST].sz[0].h);
        get_bmp_size ("bmp/hero/hero_walk_w2.bmp", &hero->walk[WEST].sz[1].w, &hero->walk[WEST].sz[1].h);
        get_bmp_size ("bmp/hero/hero_walk_w3.bmp", &hero->walk[WEST].sz[2].w, &hero->walk[WEST].sz[2].h);


	hero->walk[EAST].image[0] = LoadImage("bmp/hero/hero_walk_e1.bmp");
        hero->walk[EAST].image[1] = LoadImage("bmp/hero/hero_walk_e2.bmp");
        hero->walk[EAST].image[2] = LoadImage("bmp/hero/hero_walk_e3.bmp");

	get_bmp_size ("bmp/hero/hero_walk_e1.bmp", &hero->walk[EAST].sz[0].w, &hero->walk[WEST].sz[0].h);
        get_bmp_size ("bmp/hero/hero_walk_e2.bmp", &hero->walk[EAST].sz[1].w, &hero->walk[WEST].sz[1].h);
        get_bmp_size ("bmp/hero/hero_walk_e3.bmp", &hero->walk[EAST].sz[2].w, &hero->walk[WEST].sz[2].h);


	/* Attacking with Sword */
	
	hero->attack[NORTH].image[0] = LoadImage("bmp/hero/hero_attack_n1.bmp");
        hero->attack[NORTH].image[1] = LoadImage("bmp/hero/hero_attack_n2.bmp");
        hero->attack[NORTH].image[2] = LoadImage("bmp/hero/hero_attack_n3.bmp");
        hero->attack[NORTH].image[3] = LoadImage("bmp/hero/hero_attack_n4.bmp");

	get_bmp_size ("bmp/hero/hero_attack_n1.bmp", &hero->attack[NORTH].sz[0].w, &hero->walk[NORTH].sz[0].h);
	get_bmp_size ("bmp/hero/hero_attack_n2.bmp", &hero->attack[NORTH].sz[1].w, &hero->walk[NORTH].sz[1].h);
	get_bmp_size ("bmp/hero/hero_attack_n3.bmp", &hero->attack[NORTH].sz[2].w, &hero->walk[NORTH].sz[2].h);
        get_bmp_size ("bmp/hero/hero_attack_n4.bmp", &hero->attack[NORTH].sz[3].w, &hero->walk[NORTH].sz[3].h);


        hero->attack[NE].image[0] = LoadImage("bmp/hero/hero_attack_ne1.bmp");
        hero->attack[NE].image[1] = LoadImage("bmp/hero/hero_attack_ne2.bmp");
        hero->attack[NE].image[2] = LoadImage("bmp/hero/hero_attack_ne3.bmp");
        hero->attack[NE].image[3] = LoadImage("bmp/hero/hero_attack_ne4.bmp");

        get_bmp_size ("bmp/hero/hero_attack_ne1.bmp", &hero->attack[NE].sz[0].w, &hero->walk[NE].sz[0].h);
        get_bmp_size ("bmp/hero/hero_attack_ne2.bmp", &hero->attack[NE].sz[1].w, &hero->walk[NE].sz[1].h);
        get_bmp_size ("bmp/hero/hero_attack_ne3.bmp", &hero->attack[NE].sz[2].w, &hero->walk[NE].sz[2].h);
        get_bmp_size ("bmp/hero/hero_attack_ne4.bmp", &hero->attack[NE].sz[3].w, &hero->walk[NE].sz[3].h);

        hero->attack[NW].image[0] = LoadImage("bmp/hero/hero_attack_nw1.bmp");
        hero->attack[NW].image[1] = LoadImage("bmp/hero/hero_attack_nw2.bmp");
        hero->attack[NW].image[2] = LoadImage("bmp/hero/hero_attack_nw3.bmp");
        hero->attack[NW].image[3] = LoadImage("bmp/hero/hero_attack_nw4.bmp");

	get_bmp_size ("bmp/hero/hero_attack_nw1.bmp", &hero->attack[NW].sz[0].w, &hero->walk[NW].sz[0].h);
        get_bmp_size ("bmp/hero/hero_attack_nw2.bmp", &hero->attack[NW].sz[1].w, &hero->walk[NW].sz[1].h);
        get_bmp_size ("bmp/hero/hero_attack_nw3.bmp", &hero->attack[NW].sz[2].w, &hero->walk[NW].sz[2].h);
        get_bmp_size ("bmp/hero/hero_attack_nw4.bmp", &hero->attack[NW].sz[3].w, &hero->walk[NW].sz[3].h);

        hero->attack[SOUTH].image[0] = LoadImage("bmp/hero/hero_attack_s1.bmp");
        hero->attack[SOUTH].image[1] = LoadImage("bmp/hero/hero_attack_s2.bmp");
        hero->attack[SOUTH].image[2] = LoadImage("bmp/hero/hero_attack_s3.bmp");
        hero->attack[SOUTH].image[3] = LoadImage("bmp/hero/hero_attack_s4.bmp");

	get_bmp_size ("bmp/hero/hero_attack_s1.bmp", &hero->attack[SOUTH].sz[0].w, &hero->walk[SOUTH].sz[0].h);
        get_bmp_size ("bmp/hero/hero_attack_s2.bmp", &hero->attack[SOUTH].sz[1].w, &hero->walk[SOUTH].sz[1].h);
        get_bmp_size ("bmp/hero/hero_attack_s3.bmp", &hero->attack[SOUTH].sz[2].w, &hero->walk[SOUTH].sz[2].h);
        get_bmp_size ("bmp/hero/hero_attack_s4.bmp", &hero->attack[SOUTH].sz[3].w, &hero->walk[SOUTH].sz[3].h);

        hero->attack[SE].image[0] = LoadImage("bmp/hero/hero_attack_se1.bmp");
        hero->attack[SE].image[1] = LoadImage("bmp/hero/hero_attack_se2.bmp");
        hero->attack[SE].image[2] = LoadImage("bmp/hero/hero_attack_se3.bmp");
        hero->attack[SE].image[3] = LoadImage("bmp/hero/hero_attack_se4.bmp");

	get_bmp_size ("bmp/hero/hero_attack_se1.bmp", &hero->attack[SE].sz[0].w, &hero->walk[SE].sz[0].h);
        get_bmp_size ("bmp/hero/hero_attack_se2.bmp", &hero->attack[SE].sz[1].w, &hero->walk[SE].sz[1].h);
        get_bmp_size ("bmp/hero/hero_attack_se3.bmp", &hero->attack[SE].sz[2].w, &hero->walk[SE].sz[2].h);
        get_bmp_size ("bmp/hero/hero_attack_se4.bmp", &hero->attack[SE].sz[3].w, &hero->walk[SE].sz[3].h);

        hero->attack[SW].image[0] = LoadImage("bmp/hero/hero_attack_sw1.bmp");
        hero->attack[SW].image[1] = LoadImage("bmp/hero/hero_attack_sw2.bmp");
        hero->attack[SW].image[2] = LoadImage("bmp/hero/hero_attack_sw3.bmp");
        hero->attack[SW].image[3] = LoadImage("bmp/hero/hero_attack_sw4.bmp");

	get_bmp_size ("bmp/hero/hero_attack_sw1.bmp", &hero->attack[SW].sz[0].w, &hero->walk[SW].sz[0].h);
        get_bmp_size ("bmp/hero/hero_attack_sw2.bmp", &hero->attack[SW].sz[1].w, &hero->walk[SW].sz[1].h);
        get_bmp_size ("bmp/hero/hero_attack_sw3.bmp", &hero->attack[SW].sz[2].w, &hero->walk[SW].sz[2].h);
        get_bmp_size ("bmp/hero/hero_attack_sw4.bmp", &hero->attack[SW].sz[3].w, &hero->walk[SW].sz[3].h);

        hero->attack[WEST].image[0] = LoadImage("bmp/hero/hero_attack_w1.bmp");
        hero->attack[WEST].image[1] = LoadImage("bmp/hero/hero_attack_w2.bmp");
        hero->attack[WEST].image[2] = LoadImage("bmp/hero/hero_attack_w3.bmp");
        hero->attack[WEST].image[3] = LoadImage("bmp/hero/hero_attack_w4.bmp");

	get_bmp_size ("bmp/hero/hero_attack_w1.bmp", &hero->attack[WEST].sz[0].w, &hero->walk[WEST].sz[0].h);
        get_bmp_size ("bmp/hero/hero_attack_w2.bmp", &hero->attack[WEST].sz[1].w, &hero->walk[WEST].sz[1].h);
        get_bmp_size ("bmp/hero/hero_attack_w3.bmp", &hero->attack[WEST].sz[2].w, &hero->walk[WEST].sz[2].h);
        get_bmp_size ("bmp/hero/hero_attack_w4.bmp", &hero->attack[WEST].sz[3].w, &hero->walk[WEST].sz[3].h);


        hero->attack[EAST].image[0] = LoadImage("bmp/hero/hero_attack_e1.bmp");
        hero->attack[EAST].image[1] = LoadImage("bmp/hero/hero_attack_e2.bmp");
        hero->attack[EAST].image[2] = LoadImage("bmp/hero/hero_attack_e3.bmp");
        hero->attack[EAST].image[3] = LoadImage("bmp/hero/hero_attack_e4.bmp");
	
	get_bmp_size ("bmp/hero/hero_attack_e1.bmp", &hero->attack[EAST].sz[0].w, &hero->walk[EAST].sz[0].h);
        get_bmp_size ("bmp/hero/hero_attack_e2.bmp", &hero->attack[EAST].sz[1].w, &hero->walk[EAST].sz[1].h);
        get_bmp_size ("bmp/hero/hero_attack_e3.bmp", &hero->attack[EAST].sz[2].w, &hero->walk[EAST].sz[2].h);
        get_bmp_size ("bmp/hero/hero_attack_e4.bmp", &hero->attack[EAST].sz[3].w, &hero->walk[EAST].sz[3].h);

	/* hero throwing spell */
	/*
        hero->spell[NORTH][0] = LoadImage("bmp/hero/hero_spell_n1.bmp");
        hero->spell[NORTH][1] = LoadImage("bmp/hero/hero_spell_n2.bmp");
        hero->spell[NORTH][2] = LoadImage("bmp/hero/hero_spell_n3.bmp");
        hero->spell[NORTH][3] = LoadImage("bmp/hero/hero_spell_n4.bmp");

        hero->spell[NE][0] = LoadImage("bmp/hero/hero_spell_ne1.bmp");
        hero->spell[NE][1] = LoadImage("bmp/hero/hero_spell_ne2.bmp");
        hero->spell[NE][2] = LoadImage("bmp/hero/hero_spell_ne3.bmp");
        hero->spell[NE][3] = LoadImage("bmp/hero/hero_spell_ne4.bmp");

        hero->spell[NW][0] = LoadImage("bmp/hero/hero_spell_nw1.bmp");
        hero->spell[NW][1] = LoadImage("bmp/hero/hero_spell_nw2.bmp");
        hero->spell[NW][2] = LoadImage("bmp/hero/hero_spell_nw3.bmp");
        hero->spell[NW][3] = LoadImage("bmp/hero/hero_spell_nw4.bmp");

        hero->spell[SOUTH][0] = LoadImage("bmp/hero/hero_spell_s1.bmp");
        hero->spell[SOUTH][1] = LoadImage("bmp/hero/hero_spell_s2.bmp");
        hero->spell[SOUTH][2] = LoadImage("bmp/hero/hero_spell_s3.bmp");
        hero->spell[SOUTH][3] = LoadImage("bmp/hero/hero_spell_s4.bmp");

        hero->spell[SE][0] = LoadImage("bmp/hero/hero_spell_se1.bmp");
        hero->spell[SE][1] = LoadImage("bmp/hero/hero_spell_se2.bmp");
        hero->spell[SE][2] = LoadImage("bmp/hero/hero_spell_se3.bmp");
        hero->spell[SE][3] = LoadImage("bmp/hero/hero_spell_se4.bmp");

        hero->spell[SW][0] = LoadImage("bmp/hero/hero_spell_sw1.bmp");
        hero->spell[SW][1] = LoadImage("bmp/hero/hero_spell_sw2.bmp");
        hero->spell[SW][2] = LoadImage("bmp/hero/hero_spell_sw3.bmp");
        hero->spell[SW][3] = LoadImage("bmp/hero/hero_spell_sw4.bmp");

        hero->spell[WEST][0] = LoadImage("bmp/hero/hero_spell_w1.bmp");
        hero->spell[WEST][1] = LoadImage("bmp/hero/hero_spell_w2.bmp");
        hero->spell[WEST][2] = LoadImage("bmp/hero/hero_spell_w3.bmp");
        hero->spell[WEST][3] = LoadImage("bmp/hero/hero_spell_w4.bmp");

        hero->spell[EAST][0] = LoadImage("bmp/hero/hero_spell_e1.bmp");
        hero->spell[EAST][1] = LoadImage("bmp/hero/hero_spell_e2.bmp");
        hero->spell[EAST][2] = LoadImage("bmp/hero/hero_spell_e3.bmp");
        hero->spell[EAST][3] = LoadImage("bmp/hero/hero_spell_e4.bmp");
	*/

}

void
LoadImages (void)
{

	extern SDL_Surface *wood_stake_vs, *wood_stake_hl;

	/* We now load images on the fly (On a MAP_FRAME by MAP_FRAME basis) */

	/* However ... */
	/* We need the followiNg loaded in memory at all times */
	/* PLAYER */

	lavren = LoadImage ("bmp/hero/lavren.bmp");
	coin_blue = LoadImage ("bmp/items/coin_blue.bmp");
	coin_red = LoadImage ("bmp/items/coin_red.bmp");
	coin_purple = LoadImage ("bmp/items/coin_purple.bmp");

	/* Lavrens spirit (for boundary detection) */
	spirit[0] = LoadImage ("bmp/hero/spirit.bmp"); 
	spirit[1] = spirit[0];

	magic_image[FLAME_SPELL] = LoadImage ("bmp/magic/magic_flame.bmp");

	/* BLANK BACKGROUND */
	blank = LoadImage ("bmp/landscape/blank1.bmp");
	blank_grass1 = LoadImage("bmp/landscape/blank_grass1.bmp");
	blank_grass2 = LoadImage("bmp/landscape/blank_grass2.bmp");

	dirt_path = LoadImage("bmp/landscape/dirt_path1.bmp");
	magenta_rec = LoadImage("bmp/misc/magenta_rec.bmp");
	magenta_rec2 = LoadImage("bmp/misc/magenta_rec2.bmp");
	magenta_rec3 = LoadImage("bmp/misc/magenta_rec3.bmp");
	magenta_top = LoadImage("bmp/misc/magenta_top.bmp");
	ParticleDot = LoadAlphaImage ("bmp/misc/dot.png");
	ParticleDotBlue = LoadAlphaImage ("bmp/misc/dot_blue.png");
	ParticleDotRed = LoadAlphaImage ("bmp/misc/dot_red.png");
}

bool
testKey (SDLKey key)
{
	Uint8 *keyState = SDL_GetKeyState (NULL);

	if (key < 0 || key >= 322)
	{
		printf ("testKey() Invalid Key\n");
		return false;
	}

	return keyState[key];
}
