#include "rpg.h"


int
ip_connect (unsigned long ip, int port)
{
	int sock, n;
	struct sockaddr_in saddr;
  	unsigned long sflag = 0;

  	if ((sock = socket (AF_INET, SOCK_STREAM, 0)) == -1)
    		return -1;

  	memset (&saddr, 0, sizeof (struct sockaddr_in));

  	saddr.sin_family = AF_INET;
  	saddr.sin_port = htons (port);
  	saddr.sin_addr.s_addr = ip;

  	sflag = fcntl (sock, F_GETFL, 0);
  	fcntl (sock, F_SETFL, sflag | O_NONBLOCK);

  	if ((n = connect (sock, (struct sockaddr *) &saddr, sizeof (struct sockaddr_in)) < 0))
    		if (errno != EINPROGRESS)
      			return -1;

  	return sock;
}

int
socket_status(int sfd, suseconds_t msecs)
{
	int status, n;
  	u_long len = 4;
  	fd_set wset, rset;
  	struct timeval tval;

	FD_ZERO (&rset);
  	FD_ZERO (&wset);

  	FD_SET (sfd, &rset);
	FD_SET (sfd, &wset);

  	tval.tv_sec = 0;
  	tval.tv_usec = msecs;

  	select (sfd + 1, NULL, &wset, &rset, msecs ? &tval : NULL);

        if (FD_ISSET (sfd, &rset))
               return SOCKREAD;

  	if (FD_ISSET (sfd, &wset))
		return SOCKWRITE;
	
	return 0; 
}

char *
recvbuf (int sock)
{
	char *buf = (char *) malloc (2049);
	char *p;
  	int c;

	printf("Receiving data!\n");
  	if (recv (sock, buf, 2049, 0) == -1)
		return NULL;

  	return buf;
}

int send_data (int sock, char *buf)
{
	int len = strlen(buf);

	if (write (sock, buf, len) != len)
		return -1;
	
	return len;
}
	
/* Returns socket */
int bind_connection(void)
{
	
	int sockfd, ss, len, bytes;
	int newfd;
	socklen_t sin_size;
	unsigned long sflag;

  	struct sockaddr_in my_addr;
  	struct sockaddr_in their_addr;

  	char passwd[1024];
  	char *prompt = "Password: ";
  	char *gp;
	fd_set wset, rset;

  	if ((sockfd = socket (AF_INET, SOCK_STREAM, 0)) == -1)
    	{
      		perror ("socket");
      		exit (1);
    	}

	//sflag = fcntl (sockfd, F_GETFL, 0);
        //fcntl (sockfd, F_SETFL, sflag | O_NONBLOCK);

 	my_addr.sin_family = AF_INET;
  	my_addr.sin_port = htons (GAME_PORT);
  	my_addr.sin_addr.s_addr = INADDR_ANY;
  	bzero (&(my_addr.sin_zero), 8);

	printf("Listening for connection on port %d...\n", GAME_PORT);

  	if (bind (sockfd, (struct sockaddr *) &my_addr, sizeof (struct sockaddr)) == -1)
    	{
      		perror ("bind");
      		exit (1);
   	}
  	
	//sflag = fcntl (sockfd, F_GETFL, 0);
	if (fcntl (sockfd, F_SETFL, O_NONBLOCK) == -1)
	{
		perror("fcntl");
		exit(1);
	}

	if (listen (sockfd, 5) == -1)
    	{
      		perror ("listen");
      		exit (1);
    	}
  
	sin_size = sizeof (their_addr);
	
	if ((newfd = accept (sockfd, (struct sockaddr *) &their_addr, &sin_size)) == -1)
        {
        	perror ("accept");
        	exit (1);
       	}
	printf("Received connection from %s\n", inet_ntoa(their_addr.sin_addr));
	return newfd;
}


