#include "rpg.h"

/* Get heigth of bitmap */
int get_bmp_size(char *file, int *w, int *h)
{
	int fd;
	uint8_t *mem;
	struct stat st;

	/* bitmap info */
	bmp_info *binfo; 
	
	if ((fd = open(file, O_RDONLY)) == -1)
	{
		perror("open:");
		return -1;
	}
	
	if (fstat(fd, &st) < 0)
	{	
		perror("fstat:");
		return -1;
	}

	mem = (uint8_t *)mmap(NULL, st.st_size, PROT_READ, MAP_PRIVATE, fd, 0);
	if (mem == MAP_FAILED)
	{
		perror("mmap:");
		return -1;
	}

	/* Check for magic BM (the 'P' seems to vary so exclude) */
	if (memcmp((uint8_t *)mem, "\x42\x4d", 2) != 0)
	{
		printf("File %s is not in the bitmap file format\n", file);
		return -1;
	}

	binfo = (bmp_info *)(mem + 14);
	
	*w = binfo->width;
	*h = binfo->height;

	close(fd);
	munmap(NULL, st.st_size);
	return 0;
}

	
