/*
 * Quick and sloppy ass save code. Will obfuscate the save files eventually 
 * to prevent cheating.... (or should I? ;p)
 *
 * Ryan O'Neill 2009
 */

#include "rpg.h"

extern int no_sound;

#define DELIM ":\n"
void collect_save_data(struct save_data *sd, int x, int y)
{
	extern struct player_stats stats;
	extern struct inventory inventory;
	extern SDL_Surface *screen;
	extern int ActiveWorld;
	extern int ITEM_COUNT;
	extern TTF_Font *small_font;
 	
	SDL_Color font_fg = {0x00, 0x00, 0x00, 0x00};
	int i;

	SDL_Surface *text;

	sd->x = x;
        sd->y = y;
        
	sd->ActiveSword.id = inventory.ActiveSword.id;
        sd->ActiveSpell.id = inventory.ActiveSpell.id;
        sd->ActiveArmor.id = inventory.ActiveArmor.id;

        /* ACTIVE FRAME */
        sd->ActiveWorld = ActiveWorld;
        sd->ActiveSword.damage = inventory.ActiveSword.damage;
        sd->ActiveSpell.damage = inventory.ActiveSpell.damage;
        sd->ActiveArmor.damage_intake = inventory.ActiveArmor.damage_intake;
        sd->stats = stats;
        sd->next_level = stats.NextLevel;
        sd->item_count = ITEM_COUNT;

        for (i = 0; i < ITEM_COUNT; i++)
        {
        	sd->item[i].item_id = inventory.items[i].item_id;
                sd->item[i].quanity = inventory.items[i].quanity;
        }

        text = TTF_RenderText_Blended(small_font, "Saving game...", font_fg);
        drawSprite(text, screen, 0, 0, 200, 5, 60, 10);
        SDL_Flip(screen);
        SDL_Delay(1000);
}

	
int
save_game (int game_id, struct save_data sd)
{
	FILE *fd;
	int i;

	char path[255];

	sprintf (path, "%s/game.%d", SAVE_PATH, game_id);

	if ((fd = fopen (path, "w+")) == NULL)
	{
		printf ("Unable to open save file: %s\n", strerror (errno));
		return -1;
	}

	/* WRITE COORDINATES */
	fprintf (fd, "%d:%d", sd.x, sd.y);

	fprintf (fd, "\n");
	if (sd.item_count == 0)
		fprintf (fd, "0");
	else
	{
		/* WRITE ACTIVELY OWNED/USED ITEMS */
		for (i = 0; i < sd.item_count; i++)
			fprintf (fd, "%d-%d,", sd.item[i].item_id, sd.item[i].quanity);
	}
	fprintf (fd, "\n");
	fprintf (fd, "%d:%d:%d:%d:%d:%d:%d",
					 sd.ActiveSword.id, sd.ActiveSword.damage,
					 sd.ActiveSpell.id, sd.ActiveSpell.damage,
					 sd.ActiveArmor.id, sd.ActiveArmor.damage_intake, sd.ActiveWorld);

	fprintf (fd, "\n");

	/* Player stats */
	fprintf (fd, "%d:%d:%d:%d\n", sd.stats.hp, sd.stats.mp, sd.stats.level,
					 sd.stats.gold);

	fprintf (fd, "%d\n", sd.item_count);
	fprintf (fd, "%d\n", sd.next_level);

	if (no_sound)
		fprintf (fd, "no_sound");
	else
		fprintf (fd, "sound");
	fprintf (fd, "\n");
	fprintf (fd, "%s", SAVE_MAGIC);
	fflush (fd);
	fclose (fd);
	return 1;
}

int
load_game (char *path, struct save_data *sd)
{
	FILE *fd, *fd2;
	char *p, *q, buf[255], tmp[255] = {0};
	int i, zero_items = 0;
	fpos_t *off;

	if ((fd = fopen (path, "r")) == NULL)
	{
		printf ("Unable to open save file: %s\n", strerror (errno));
		return -1;
	}

	fgets (buf, sizeof (buf), fd);
	p = strchr (buf, ':');
	*p = '\0';

	sd->x = atoi (buf);
	sd->y = atoi (p + 1);

	printf ("sd->x = %d sd->y = %d\n", sd->x, sd->y);

	fgets (buf, sizeof (buf), fd);
	if (buf[0] == '0')
	{
		zero_items++;
		sd->item_count = 0;
		goto skip_items;
	}
	p = strtok(buf, ",");
	q = strchr(buf, '-');
	if (q == NULL)
	{
		printf("Unable to properly read save file\n");
		exit(-1);
	}

	sd->item[0].item_id = atoi(p);
	sd->item[0].quanity = atoi(q + 1);
	
	for (i = 1; (p = strtok (NULL, ",")) != NULL; i++)
	{
		if (*p == 0x20 || *p == '\n')
			break;
		sd->item[i].item_id = atoi (p);
		sd->item[i].quanity = atoi (q + 1);
	}

skip_items:
	fgets (buf, sizeof (buf), fd);

	p = strtok (buf, DELIM);
	sd->ActiveSword.id = atoi (p);

	p = strtok (NULL, DELIM);
	sd->ActiveSword.damage = atoi (p);

	p = strtok (NULL, DELIM);
	sd->ActiveSpell.id = atoi (p);

	p = strtok (NULL, DELIM);
	sd->ActiveSpell.damage = atoi (p);

	p = strtok (NULL, DELIM);
	sd->ActiveArmor.id = atoi (p);

	p = strtok (NULL, DELIM);
	sd->ActiveArmor.damage_intake = atoi (p);

	p = strtok (NULL, DELIM);
	sd->ActiveWorld = atoi (p);

	fgets (buf, sizeof (buf), fd);
	p = strtok (buf, DELIM);
	sd->stats.hp = atoi (p);

	p = strtok (NULL, DELIM);
	sd->stats.mp = atoi (p);

	p = strtok (NULL, DELIM);
	sd->stats.level = atoi (p);

	p = strtok (NULL, DELIM);
	sd->stats.gold = atoi (p);

	//sd->item_count = i / 2;
	/*
	for (i = 0; i < sd->item_count; i++)
		printf ("Item: %d Quanity: %d\n", sd->item[i].item_id,
						sd->item[i].quanity);
	*/
	fgets (buf, sizeof (buf), fd);
	sd->item_count = atoi(buf);

	fgets (buf, sizeof (buf), fd);
	sd->next_level = atoi(buf);

	fgets (buf, sizeof (buf), fd);
	
	if (strncasecmp(buf, "no_sound", 8) == 0)
		no_sound = 1;

	fgets (buf, sizeof (buf), fd);
	if (strcmp (buf, SAVE_MAGIC))
	{
		printf ("Corrupted save file, exiting...\n");
		exit (-1);
	}
	
	printf("%d %d %d %d\n", sd->ActiveWorld, sd->stats.hp, sd->stats.mp,  sd->stats.level );
	fclose (fd);
}
